#!/usr/bin/perl
#
#########################################################
#                                                       #
#  This file was automatically generated by configure.  #
#  DO NOT MODIFY DIRECTLY, modify the .in file and      #
#  run configure to rebuild this file.                  #
#                                                       #
#########################################################
#
#  The pkgbuild build engine
#
#  Copyright (c) 2004, 2011, Oracle and/or its affiliates. All rights reserved.
#
#  pkgbuild is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License 
#  version 2 published by the Free Software Foundation.
#
#  pkgbuild is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#  As a special exception to the GNU General Public License, if you
#  distribute this file as part of a program that contains a
#  configuration script generated by Autoconf, you may include it under
#  the same distribution terms that you use for the rest of that program.
#
#  Authors:  Laszlo Peter  <laca@sun.com>
#            Petr Sobotka  <sobotkap@gmail.com>
#

#use strict;
use warnings;
use Getopt::Long qw(:config gnu_compat no_auto_abbrev bundling pass_through);
use rpm_spec;
use pkgdb;
use ips_utils;
use File::Basename;

my $myname = "pkgbuild";
my $myversion = "1.3.104";
my $version_printed = 0;
my $debug_level = 0;
my $verbose = 1;
my $build_command;
my $build_skip = 0;
my $interactive_mode = 0;
my $check_deps = 1;
my $pkgdb;
my $target = '';
my $ips_utils = new ips_utils;
my $sourcepkg = 1;

my $ips_server = $ENV{PKGBUILD_IPS_SERVER};
if (not defined($ips_server)) {
    if (defined ($ips_utils)) {
	$ips_server = $ips_utils->get_local_ips_server();
    }
}
my $server_error = ips_utils::verify_server ($ips_server);
if (defined $server_error) {
    print STDERR "ERROR: invalid PKGBUILD_IPS_SERVER setting: $server_error\n";
    exit (1);
}

my $src_ips_server = $ENV{PKGBUILD_SRC_IPS_SERVER};
if (not defined($src_ips_server)) {
    $src_ips_server = $ips_server;
}

my $mydir = `pwd`;
chomp ($mydir);
my @spec_names = ();

my $arch;
my $build_arch;
my $os;
my $os_rel;

sub debug_print ($) {
    my $msg = shift;
    if ($debug_level > 0) {
	print "DEBUG:" . $msg . "\n";
    }
}

sub init () {
    $arch = `uname -p`;
    chomp ($arch);
    if ($arch eq "unknown") {
	$arch = `uname -m`;
	chomp ($arch);
	if ($arch eq 'i586') {
	    $arch = 'i386';
	} elsif ($arch eq 'i686') {
	    $arch = 'i386';
	}
    }
    if ($target ne '') {
        $arch = $target;
	rpm_spec::set_target($target);
    }
    $build_arch = $arch;

    $os = `uname -s`;
    chomp ($os);
    $os = lc($os);
    $os_rel = `uname -r`;
    chomp ($os_rel);
    if ($os eq 'sunos') {
	if ($os_rel =~ /^5\./) {
	    $os = 'solaris';
	}
    }
}

my @predefines = ();

sub add_define ($$) {
    shift;
    my $def = shift;

    push (@predefines, $def);
}

my %build_phases = ('p', 'p', 
		    'c', 'pc',
		    'i', 'pci',
		    'b', 'pcib',
		    'a', 'pciba',
		    's', 's');

sub short_circuit_option {
    if (defined ($build_command)) {
	$build_command = substr($build_command, length($build_command)-1);
    } else {
	%build_phases = ('p', 'p',
			 'c', 'c',
			 'i', 'i',
			 'b', 'b',
			 's', 's',
			 'a', 'a');
    }
}

sub set_build_command ($$) {
    shift;
    my $key = shift;

    if (defined $build_command) {
	fatal ("only one major mode may be specified");
    }
    if ($key =~ /^[abicps]$/) {
	$build_command = $build_phases{$key};
    } elsif ($key eq 'l') {
	fatal ("-bl not implemented");
    } else {
	fatal ("--build (-b) requires one of a,b,i,c,p,l,s as its sole argument");
    }
}

sub set_rebuild ($) {
    shift;
    my $pkg = shift;

    if (defined $build_command) {
	fatal ("only one major mode may be specified");
    }
    if (not $pkg =~ /^\//) {
	$pkg = "$mydir/$pkg";
    }

    if ( -f $pkg ) {
	# check if it's a datastream pkg
	my $ftype = `/usr/bin/file $pkg | cut -f2 -d:`;
	chomp ($ftype);
	if (not $ftype =~ /package datastream/) {
	    fatal ("file $pkg is not a package datastream");
	}
	my $tmpdir=`mktemp -d`;
	chomp ($tmpdir);
	system ("/usr/bin/pkgtrans -o $pkg $tmpdir all");
	$pkg = `/bin/ls -d $tmpdir/* | head -1`;
	chomp ($pkg);
	print "pkg is $pkg\n";
    }
    $build_command = $build_phases{'b'};
    my $main_spec = `grep '^1 s none .*/\.\.main\.spec=' $pkg/pkgmap 2>&1`;
    if ($? == 0) {
	chomp ($main_spec);
	$main_spec =~ s/^1 s none (.*\/)\.\.main\.spec=(.*)/$1$2/;
	$main_spec = "$pkg/reloc/$main_spec";
	my $src_topdir = $main_spec;
	$src_topdir =~ s/\/SPECS\/[^\/]*\.spec$//;
	add_define (0, "_sourcedir $src_topdir/SOURCES");
	add_define (0, "_specdir $src_topdir/SPECS");
	@spec_names = ($main_spec);
	return 1;
    }

    if (-l "$pkg/SPECS/..main.spec") {
	add_define (0, "_sourcedir $pkg/SOURCES");
	add_define (0, "_specdir $pkg/SPECS");
	$main_spec = readlink ("$pkg/SPECS/..main.spec");
	$main_spec = "$pkg/SPECS/$main_spec";
	@spec_names = ($main_spec);
	return 1;
    }

    fatal ("$pkg is not a source package");
}

sub process_with ($$) {
    my $with = shift;
    my $opt = shift;

    if ($with ne "with" and $with ne "without") {
	fatal ("Internal error in sub process_with()");
    }
    my $optname = $opt;
    $optname =~ tr /\-/_/;
    push (@predefines, "_${with}_${optname} --${with}-${opt}");
}

my $pkgformat = "filesystem";
if (defined ($ENV{PKGBUILD_IPS_SERVER}) or
    (defined ($ips_utils) and $ips_utils->is_depotd_enabled())) {
    $pkgformat = "ips";
}
sub set_pkgformat ($) {
    shift;
    my $format = shift;

    if ($format eq "fs" or $format eq "filesystem") {
	$pkgformat = "filesystem";
    } elsif ($format eq "ds" or $format eq "datastream") {
	$pkgformat = "datastream";
    } elsif ($format eq "ips") {
	$pkgformat = "ips";
    } else {
	fatal ("Invalid argument to pkgformat option: $format");
    }
}

sub process_options {
    if (not GetOptions ('debug=n'   => \$debug_level,
		'help'      => \&usage,
		'version'   => \&print_version,
		'b=s'       => \&set_build_command,
		'v+'        => \$verbose,
		'define=s'  => \&add_define,
		'deps!'     => \$check_deps,
		'interactive!' => \$interactive_mode,
		'sourcepkg!' => \$sourcepkg,
		'bp'        => sub { set_build_command (0, 'p'); },
		'bl'        => sub { fatal ("-bl not implemented\n") },
		'bc'        => sub { set_build_command (0, 'c'); },
		'bi'        => sub { set_build_command (0, 'i'); },
		'bb'        => sub { set_build_command (0, 'b'); },
		'ba'        => sub { set_build_command (0, 'a'); },
		'bs'        => sub { set_build_command (0, 's'); },
		'rebuild=s' => \&set_rebuild,
		'with=s'    => \&process_with,
		'without=s' => \&process_with,
		'pkgformat=s' => \&set_pkgformat,
		'short-circuit' => \&short_circuit_option, 
		'build=s'   => \$build_command,
		'target=s'  => \$target,
		'rcfile=s'  => sub { print "--rcfile option not implemented\n" },
			'<>' => \&process_args)) {
	exit 1;
    }
}

sub process_args () {
    my $arg = shift;

    if ($arg =~ /^--with-(.*)/) {
	process_with ("with", $1);
	return;
    } elsif ($arg =~ /^--without-(.*)/) {
	process_with ("without", $1);
	return;
    } elsif ($arg =~ /^-/) {
	fatal ("Unknown option: $arg\n");
    }
    
    push (@spec_names, $arg);
}

sub print_version () {
    $version_printed = 1;
    print "$myname version $myversion\n";
}

sub usage () {
    print_version();
    print <<_EOF_;
Copyright 2003-2008 Sun Microsystems, Inc.
This program may be freely redistributed under the terms of the GNU GPLv2

* = the option is implemented 

 Usage:
*  --help                  - print this message
*  --version               - print the version of rpm being used
*  --interactive           - start a shell in the build directory if fails
                             and allow to continue after the shell terminates
   all modes support the following arguments:
      --rcfile <file>      - use <file> instead of /etc/rpmrc and \$HOME/.rpmrc
*    -v                    - be a little more verbose
*    -vv                   - be incredibly verbose (for debugging)
*   -b<stage> <spec>
    -t<stage> <tarball>    - build package, where <stage> is one of:
*         p                - prep (unpack sources and apply patches)
          l                - list check (do some cursory checks on %files)
*         c                - compile (prep and compile)
*         i                - install (prep, compile, install)
*         b                - binary package (prep, compile, install, package)
*         s                - source package (install, package)
*         a                - bin/src package (prep, compile, install, package)
*     --short-circuit      - skip straight to specified stage (for c,i,b)
*     --nosourcepkg        - do not create a source package
      --clean              - remove build tree when done
      --rmsource           - remove sources and spec file when done
      --sign               - generate PGP/GPG signature
      --buildroot <dir>    - use <dir> as the build root
      --target=<platform>+ - build the packages for the build targets
                             platform1...platformN.
      --nobuild            - do not execute any stages
      --timecheck <secs>   - set the time check to <secs> seconds (0 disables)
*     --define "<name> <value>"
                           - define <name> as <value> as if you had
			     "%define <name> <value>" in the spec file 
*     --with-foo or --with foo
                           - same as "%define _with_foo --with-foo"
*     --without-foo or --without foo
                           - same as "%define _without_foo --without-foo" 

*   --rebuild <src_pkg>    - install source package, build binary package and
                             remove spec file, sources, patches, and icons.
    --rmsource <spec>      - remove sources and spec file
    --recompile <src_pkg>  - like --rebuild, but don't build any package
*   --pkgformat={filesystem|fs|datastream|ds|ips}
                           - Create packages in filesystem or datastream
                             format.  Default: filesystem
_EOF_
# '
    exit(1);
}

sub message (@) {
    my @messages = @_;

    foreach my $msg (@messages) {
	print "$myname: $msg\n";
    }
}

my @tempfiles = ();
sub register_tempfile ($) {
    push  (@tempfiles, shift);
}

sub remove_tempfiles () {
    foreach my $tmpf (@tempfiles) {
	if ( -d $tmpf ) {
	    `rm -rf $tmpf`;
	} elsif ( -f $tmpf ) {
	    `rm -f $tmpf`;
	}
    }
}

sub fatal (@) {
    message (@_);
    remove_tempfiles ();
    exit 1;
}

sub get_versions_installed ($) {
    my $pkg = shift;

    my @retlist = ();
    if ($os eq "linux") {
	my $pkglist=`rpm -q --queryformat '%{VERSION}\t%{RELEASE}\t%{SERIAL}\n' $pkg 2>/dev/null`;
	if ($? != 0) {
	    return \@retlist;
	}
	my @pkginfos=split /\n/, $pkglist;
	foreach my $pkginfo (@pkginfos) {
	    next if not defined ($pkginfo);
	    if ($pkginfo =~ /^([^\t]*)\t([^\t]*)\t([^\t]*)$/) {
		push (@retlist, ($1, $2, $3));
	    } else {
		message ("WARNING: couldn't parse version number of $pkg");
	    }
	}
	return \@retlist;
    } elsif ($os eq "solaris") {
	my $pkglist=`/usr/bin/pkginfo -l '$pkg.*' 2>&1 | grep VERSION: | cut -f2- -d:`;
	if ($? != 0) {
	    return \@retlist;
	}
	my @pkginfos=split /\n/, $pkglist;
	foreach my $pkginfo (@pkginfos) {
	    next if not defined ($pkginfo);
	    if ($pkginfo =~ /^\s*(.*),REV=(.*)\s*$/) {
		push (@retlist, ($1, $2, undef));
	    } else {
		$pkginfo =~ s/\s*//;
		push (@retlist, ($pkginfo, undef, undef));
	    }
	}
	return \@retlist;
    } else {
	return \@retlist;
    }   
}

sub compare_version ($$$$$$$) {
    my $vers1 = shift;
    my $rev1 = shift;
    my $serial1 = shift;
    my $op = shift;
    my $vers2 = shift;
    my $rev2 = shift;
    my $serial2 = shift;

    return 1;

# FIXME: this is unfinished!
    if ($op =~ /S$/) {
	if (not defined ($serial1) or not defined ($serial2)) {
	    return 0;
	}
	my $comp_res = compare_version_string ($serial1, $serial2);
	if ($op eq "=S") {
	    if ($serial1 = $serial2) {
		return 1;
	    }
	} elsif ($op eq "<=S" or $op eq "=<S") {
	} elsif ($op eq ">=S" or $op eq "=>S") {
	}
    } else {
	if (not defined ($version1) or not defined ($version2)) {
	    return 0;
	}
	my $version_comp_res = compare_version_string ($serial1, $serial2);
	my $rev_comp_res;
	if ($version_comp_res == 0) {
	    if (not defined ($version1) or not defined ($version2)) {
		return 0;
	    }
	    my $version_comp_res = compare_version_string ($serial1, $serial2);
	}
	if ($op eq "=") {
	} elsif ($op eq "<=" or $op eq "=<") {
	} elsif ($op eq ">=" or $op eq "=>") {
	}
    }
}

sub check_dep ($$) {
    my $spec = shift;
    my $dep = shift;

    if (not defined ($dep)) {
	return 1;
    }

    if ($dep =~ /^\s*\//) {
	# Requires: /path/to/file  kind of dependency
	if (-e $dep) {
	    return 1;
	}
	return 0;
    }

    my $pkg = $dep;
    # FIXME: we're simply chopping off any version comparisons
    # should really verify them instead
    $dep =~ s/([^\s><=]+).*/$1/;
    if (not defined ($pkg)) {
	print "empty dependency: $dep\n";
	return 0;
    }
    my $ref_vers;
    my $ref_rev;
    my $ref_serial;
    my $rel_op;
    my $re_quoted_pkg = $dep;
    # quote chars with special meaning in regexps
    $re_quoted_pkg =~ s/([\+\*\(\)\[\].\\])/\\$1/g;
    if ($dep =~ /^$re_quoted_pkg\s*(=|<=|=<|>=|=>)\s*(\S*),REV=(\S*)\s*$/) {
	if ($os eq "solaris") {
	    $rel_op = $1;
	    $ref_vers = $2;
	    $ref_rev = $3;
	} else {
	    $rel_op = $1;
	    $ref_vers = "$2,REV=$3";
	    if ($ref_vers =~ /^([^-]*)-([^-]*)$/) {
		$ref_vers = $1;
		$ref_rev = $2;
	    }
	}
    } elsif ($dep =~ /^$re_quoted_pkg\s*(=|<=|=<|>=|=>)\s*(\S*)\s*$/) {
	$rel_op = $1;
	$ref_vers = $2;
	if ($os eq "linux") {
	    if ($ref_vers =~ /^([^-]*)-([^-]*)$/) {
		$ref_vers = $1;
		$ref_rev = $2;
	    }
	}
    } elsif ($dep =~ /^$re_quoted_pkg\s*(=S|<=S|=<S|>=S|=>S)\s*(\S*)\s*$/) {
	$rel_op = $1;
	$ref_serial = $2;
	if ($os eq "solaris") {
	    print "WARNING: \"Serial\" dependency tests not " .
		"implemented on Solaris\n";
	    print "WARNING: ignoring dependency \"$dep\"\n";
	    return 1;
	}
    } elsif ($dep =~ /^$re_quoted_pkg\s*$/) {
	# no version to compare to, check existance of pkg only
    } else {
	print "WARNING: could not parse dependency: $dep\n";
	return 0;
    }

    my $subpkg = $spec->find_package_by_pkg_name ($dep);
    if (not defined $subpkg) {
	if ($os eq "linux") {
	    `rpm -q $pkg`;
	    if ($? != 0) {
		`rpm -q --provides $pkg`;
		if ($? != 0) {
		    return 0;
		}
	    }
	} elsif ($os eq "solaris") {
	    # search for an SVr4 or IPS legacy package
	    `/usr/bin/pkginfo -q '$pkg.*'`;
	    if ($? == 0) {
		return 1;
	    }
	    # search for an IPS package
	    if (-x "/usr/bin/pkg") {
		my $search_out = `pkg info -l '$dep' 2>&1`;
		chomp ($search_out);
		# escape some regexp chars
		my $safepkg = $dep;
		$safepkg =~ s/\+/\\+/g;
		$safepkg =~ s/\./\\./g;
		# exact match
		if ($search_out =~ /^\s+Name:\s*${safepkg}\s*\n/s) {
		    return 1;
		}
		# suffix match
		if ($search_out =~ /^\s+Name:\s*(\S+)\/${safepkg}\s*\n/s) {
		    print "INFO: using '$1/$dep' for dependency '$pkg'\n";
		    return 1;
		}
	    }
	    return 0;
	} else {
	    print "WARNING: I don't know how to verify dependency $pkg ".
		"on this OS.\n";
	    return 1;
	}
    }

    if (defined ($ref_vers)) {
	if (defined $subpkg) {
	    my $subpkg_version = $subpkg->get_tag ("version");
	    my $subpkg_release = $subpkg->get_tag ("release");
	    my $subpkg_serial = $subpkg->get_tag ("serial");
	    my $subpkg_rev = $subpkg->get_tag ("rev");

	    if (compare_version ($ref_vers, $ref_rev, $ref_serial,
				 $rel_op, 
				 $subpkg_version, $subpkg_rev, 
				 $subpkg_serial)) {
		return 1;
	    }
	}

	my $version_list_ref = get_versions_installed ($pkg);
	if (not @$version_list_ref) {
	    return 0;
	}

	if ($rel_op =~ /S$/) {
#FIXME	    
	}
	foreach $vers_ref (@$version_list_ref) {
	    my ($version, $rev, $serial) = @$vers_ref;
	    if (compare_version ($ref_vers, $ref_rev, $ref_serial,
				 $rel_op, 
				 $version, $rev, $serial)) {
		return 1;
	    }
	}
	return 0;
    }

    return 1;
}

sub check_build_requires ($) {
    my $spec = shift;

    my @packages = $spec->get_packages ();

    foreach my $pkg (@packages) {
	my @reqss = $pkg->get_array ("buildrequires");
	foreach my $req (@reqss) {
	    next if not defined $req;
	    check_dep ($spec, $req) or
		message ("error: $req is required to build " .
			 $spec), return 0;
	}
	@reqss = $pkg->get_array ("buildconflicts");
	foreach my $req (@reqss) {
	    next if not defined $req;
	    check_dep ($spec, $req) and
		message ("error: $req conflicts with " .
			 $spec), return 0;
	}
	@reqss = $pkg->get_array ("buildprereq");
	foreach my $req (@reqss) {
	    next if not defined $req;
	    check_dep ($spec, $req) or
		message ("error: $req is required to build " .
			 $spec), return 0;
	}
    }

    return 1;
}

sub get_script_header ($) {
    my $spec = shift;

    my $error_handler = "";
    if ($interactive_mode) {
	$error_handler = "pkgbuild_start_shell () {\n" .
	    "  set +x\n" .
	    "  export PS1='pkgbuild@\\H> '\n" .
	    "  echo '*** Command failed; entering interactive mode'\n" .
	    "  echo '*** starting shell'\n" .
	    "  echo '*** when finished'\n" .
	    "  echo '***     type   exit      to continue'\n" .
	    "  echo '***     type   exit 1    to abort'\n" .
	    "\n" .
	    "  /bin/bash --noprofile --norc +o monitor -i || exit 1\n" .
	    "\n" .
	    "  set -x\n" .
	    "}\n" .
	    "\n" .
	    "trap pkgbuild_start_shell ERR\n" .
	    "\n";
    } else {
	$error_handler = "set -e\n\n";
    }
    my $buildshell = $spec->eval ('%_buildshell');
    $buildshell = "/bin/bash" unless defined ($buildshell);
    my $script = "#!${buildshell}\n\n";
    if ($buildshell eq "/bin/bash" or $buildshell eq "/usr/bin/bash") {
	$script = "#!${buildshell}\n\n" .
	    $error_handler .
	    $spec->eval ("RPM_SOURCE_DIR=\"%{_sourcedir}\"") . "\n" .
	    $spec->eval ("RPM_BUILD_DIR=\"%{_builddir}\"") . "\n" .
	    $spec->eval ("RPM_OPT_FLAGS=\"%{optflags}\"") . "\n" .
	    "RPM_ARCH=\"$build_arch\"\n" .
	    "RPM_OS=\"$os\"\n" .
	    "RPM_OS_REL=\"$os_rel\"\n" .
	    "export RPM_SOURCE_DIR RPM_BUILD_DIR RPM_OPT_FLAGS RPM_ARCH RPM_OS\n" .
	    "RPM_DOC_DIR=\"/usr/share/doc/packages/" . $spec . "\"\n" .
	    "export RPM_DOC_DIR\n" .
	    "RPM_PACKAGE_NAME=\"" . $spec . "\"\n" .
	    "RPM_PACKAGE_VERSION=\"" . $spec->eval ('%version') . "\"\n" .
	    "RPM_PACKAGE_RELEASE=\"" . $spec->eval ('%release') . "\"\n" .
	    "export RPM_PACKAGE_NAME RPM_PACKAGE_VERSION RPM_PACKAGE_RELEASE\n" .
	    $spec->eval ("RPM_BUILD_ROOT=\"%buildroot\"") . "\n" .
	    "export RPM_BUILD_ROOT\n\n" .
	    "set -x\n" .
	    "umask 022\n" .
	    "uname -a\n\n";
    }

    return $script;
}

# I couldn't find a standard perl implementation of mkdir -p so
# this is simple a recursive implementation
sub mkdir_p ($);

sub mkdir_p ($) {
    my $dir = shift;

    if (-d $dir) {
	return 1;
    }

    my $pdir = dirname ($dir);
    if (! -d $pdir) {
	mkdir_p ($pdir) or return 0;
    }

    return 1 if -d $dir;
    mkdir ($dir) or return 0;
    return 1;
}

sub url_escape ($) {
    my $url = shift;

    # FIXME: escape and url and return
    $url =~ s/@/%40/g;
    $url =~ s/,/%2C/g;
    $url =~ s/\//%2F/g;
    $url =~ s/:/%3A/g;
   return $url;
}


my $file_id = 0;
sub open_tempfile ($) {
    my $spec = shift;

    my $tempdir = $spec->eval('%{_tmppath}');
    if (not defined $tempdir) {
	$tempdir = "/tmp";
    }
    my $the_file_id = ++$file_id;
    my $fhandle = "TEMP_FILE" . $the_file_id;
    my $fname = "pkgbuild-tmp-$the_file_id.$$";
    mkdir_p ($tempdir);
    open $fhandle, ">$tempdir/$fname" or
	fatal ("failed to create temporary file $tempdir/$fname");
    return ($fhandle, "$tempdir/$fname");
}

sub do_block ($$) {
    my $spec = shift;
    my $block_name = shift;

    my $script = $spec->get_block ($block_name);
    if (not defined ($script)) {
	return 1;
    }
    my $fhandle;
    my $script_name;
    ($fhandle, $script_name) = open_tempfile ($spec);
    my $script_hdr = get_script_header ($spec);

    print $fhandle "$script_hdr";
    print $fhandle $spec->eval ("cd %{_builddir}\n\n");
    print $fhandle "$script\n" if $script;
    print $fhandle "exit 0\n";

    close $fhandle;
    my $retval;

    print "Executing(%$block_name): /bin/bash $script_name\n";
    if ($block_name eq 'build' or $block_name eq 'install') {
	my $bsdirname = $spec->eval ('%{_build_src_dir_name}');
	if ($bsdirname eq '%{_build_src_dir_name}') {
	    $bsdirname = $spec->eval ('%name-%version');
	}
	my $blddir = $spec->eval ("%{_builddir}");
	`test -d $blddir/$bsdirname && cp $script_name $blddir/$bsdirname/.pkgbuild.$block_name.sh && chmod a+x $blddir/$bsdirname/.pkgbuild.$block_name.sh`;
    }
    system ("/bin/bash $script_name");
    $retval = $?;
    unlink $script_name;
    if ($retval) {
	print "Bad exit status from $script_name (%$block_name)\n";
    }

    return (not $retval);
}


my %all_files;

sub make_pkginfo ($$) {
    my $spec = shift;
    my $package = shift;

    my $fhandle = "pkginfo" . ++$file_id;

    my $pkginfodir = $spec->eval ("%_topdir") . "/PKGMAPS/pkginfo";
    my $fname = $package->get_svr4_name() . ".pkginfo";
    open $fhandle, ">$pkginfodir/$fname" or
	fatal ("failed to create file $pkginfodir/$fname");

    my $pkgname = $package->get_tag ('SUNW_Pkg');
    $pkgname = "$package" unless $pkgname;
    print $fhandle "PKG=" . $pkgname . "\n";
    my $summary = $package->get_tag ('summary');
    $summary = $pkgname unless defined ($summary);
    print $fhandle "NAME=$summary\n";
    my $desc = $package->get_tag ('SUNW_Desc');
    if (defined ($desc)) {
        print $fhandle "DESC=$desc\n";
    } else {
        print $fhandle "DESC=$summary\n";
    }
    my $pkg_arch = get_pkg_arch($package);
    print $fhandle "ARCH=$pkg_arch\n";

    my $prodname = $package->get_tag ('SUNW_ProdName');
    print $fhandle "SUNW_PRODNAME=$prodname\n" if $prodname;

    my $prodvers = $package->get_tag ('SUNW_ProdVers');
    print $fhandle "SUNW_PRODVERS=$prodvers\n" if $prodvers;

    my $basedir = $package->get_tag ('SUNW_BaseDir');
    if (not defined ($basedir)) {
	$basedir = "/";
    }
    $basedir =~ s/(.)\/*$/$1/;

    my $orig_basedir = $basedir;
    my $basedir_opts = $package->get_tag_opts ('SUNW_BaseDir');
    if (defined ($basedir_opts)) {
	if ($basedir_opts =~ /\(relocate_from[:=](.+)\)/) {
	    $basedir = $1;
	}
    }

    my $parent_dir = $basedir;
    while ($parent_dir =~ /\// and $parent_dir ne "/") {
	$all_files{substr($parent_dir, 1)}="base directory";
	$parent_dir =~ s/\/[^\/]+$//;
    }
    
    my $pkgtype = $package->get_tag ('SUNW_PkgType');
    if (defined ($pkgtype)) {
	print $fhandle "SUNW_PKGTYPE=$pkgtype\n";
    } elsif ($basedir eq "/usr") {
	print $fhandle "SUNW_PKGTYPE=usr\n";
    } elsif ($basedir eq "/") {
	print $fhandle "SUNW_PKGTYPE=root\n";
    }

    my $pkgvers = $package->get_tag ('SUNW_PkgVers');
    $pkgvers = "1.0" unless $pkgvers;
    print $fhandle "SUNW_PKGVERS=$pkgvers\n";

    my $pkglist = $package->get_tag ('SUNW_PkgList');
    if (defined ($pkglist)) {
       print $fhandle "SUNW_PKGLIST=$pkglist\n";
    }

    my $loc = $package->get_tag ('SUNW_Loc');
    if (defined ($loc)) {
       print $fhandle "SUNW_LOC=$loc\n";
    }

    my $category = $package->get_tag ('SUNW_Category');
    if (not defined ($category)) {
	$category = "application";
    }
    print $fhandle "CATEGORY=$category\n";

    my $zone_stuff = $package->get_tag ('SUNW_Pkg_AllZones');
    if (defined ($zone_stuff)) {
	print $fhandle "SUNW_PKG_ALLZONES=$zone_stuff\n";
    }

    $zone_stuff = $package->get_tag ('SUNW_Pkg_Hollow');
    if (defined ($zone_stuff)) {
	print $fhandle "SUNW_PKG_HOLLOW=$zone_stuff\n";
    }

    $zone_stuff = $package->get_tag ('SUNW_Pkg_ThisZone');
    if (defined ($zone_stuff)) {
	print $fhandle "SUNW_PKG_THISZONE=$zone_stuff\n";
    }

    my $vendor = $package->get_tag ('Vendor');
    print $fhandle "VENDOR=$vendor\n" if $vendor;

    my $hotline = $package->get_tag ('SUNW_HotLine');
    print $fhandle "HOTLINE=$hotline\n" if $hotline;

    print $fhandle "EMAIL=\n";

    my $maxinst = $package->get_tag ('SUNW_MaxInst');
    print $fhandle "MAXINST=$maxinst\n" if $maxinst;

    my $version = $package->get_tag ('Version');
    my $rev = $package->get_tag ('SUNW_Rev');
    if (not defined $rev) {
	$rev = `date +%Y.%m.%d.%H.%M.%S`;
    }
    chomp ($rev);
    print $fhandle "VERSION=$version,REV=$rev\n";
    
    print $fhandle "BASEDIR=$orig_basedir\n";

    my @classes = $package->get_classes ();
    print $fhandle "CLASSES=none";
    foreach my $class_name (@classes) {
	next if not defined $class_name;
	next if $class_name eq "none";
	print $fhandle " $class_name"
    }
    print $fhandle "\n";

    close $fhandle;
    return "i pkginfo=$pkginfodir/$fname\n";
}

# expand macros in file $src in the contect of $spec and write the output
# to file $dst
sub eval_file ($$$) {
    my $spec = shift;
    my $src = shift;
    my $dst = shift;

    open SRC, "<$src" or
	fatal ("failed to open file $src for reading");
    open DST, ">$dst" or
	fatal ("failed to open file $dst for writing");

    while (my $line = <SRC>) {
	if ($line =~ /%({[.a-zA-Z0-9_]+}|[.a-zA-Z0-9_]+)/) {
	    print DST $spec->eval ($line);
	} else {
	    print DST $line;
	}
    }

    close SRC;
    close DST;
}

sub make_copyright ($$;$) {
    my $spec = shift;
    my $package = shift;
    my $pkgname = shift;

    my $cr_file;
    if (defined $package) {
	$cr_file = $package->get_tag ('sunw_copyright');
    } else {
	$cr_file = $spec->get_value_of ('sunw_copyright');
    }
    return undef unless defined $cr_file;

    # in case it's a URL
    $cr_file = basename($cr_file);

    my $srcdir = $spec->eval ('%_sourcedir');
    if (not -f "$srcdir/$cr_file") {
	message ("warning: copyright file $srcdir/$cr_file not found");
	return undef;
    }

    my $copyrightdir = $spec->eval ("%_pkgmapdir") . "/copyright";
    if (defined ($package) and not defined($pkgname)) {
	$pkgname = $package->get_tag ('SUNW_Pkg');
	$pkgname = "$package" unless $pkgname;
    }
    eval_file ($spec, "$srcdir/$cr_file", "$copyrightdir/${pkgname}.copyright");

    return "i copyright=$copyrightdir/${pkgname}.copyright\n";
}

sub make_depend ($$) {
    my $spec = shift;
    my $package = shift;

    my @deps = $package->get_array ("requires");

    if (not @deps) {
	print "WARNING: $package: no dependencies\n";
	return "";
    }

    my $fhandle = "pkginfo" . ++$file_id;

    my $pkgdependdir = $spec->eval ("%_pkgmapdir") . "/depend";
    my $fname = $package->get_svr4_name() . ".depend";
    my $topdir = $spec->eval ("%_topdir");
    open $fhandle, ">$pkgdependdir/$fname" or
	fatal ("failed to create file $pkgdependdir/$fname");

    foreach my $dep (@deps) {
	if (not defined ($dep)) {
	    next;
	}
	# FIXME: we're simply chopping off any version comparisons
	# should really verify them instead
	$dep =~ s/([^\s><=]+).*/$1/;
	# look for a package defined in this spec file first
	my $subpkg = $spec->find_package_by_pkg_name ($dep);
	if (defined ($subpkg)) {
	    print $fhandle "P $dep " . $subpkg->get_tag ("summary") . "\n";
	    next;
	}

	my $pkg = $pkgdb->get_svr4_pkgname($dep);
	my $pkgname = $pkgdb->get_description($dep);
	if (defined ($pkg) and defined($pkgname)) {
	    print $fhandle "P $pkg $pkgname\n"; 
	} else {
	    print "WARNING: unknown dependency $dep\n";
	    print $fhandle "P $dep\n"; 
	}
    }

    close $fhandle;
    return "i depend=$pkgdependdir/$fname\n";
}

sub make_scripts ($$) {
    my $spec = shift;
    my $package = shift;

    my $retstr = "";
    my $scriptdir = $spec->eval ("%_pkgmapdir") . "/scripts";

    my $pre = $package->get_block ("pre");
    if (defined ($pre)) {
	my $fhandle = "script" . ++$file_id;
	my $fname = $package->get_svr4_name() . ".preinstall";
	open $fhandle, ">$scriptdir/$fname" or
	    fatal ("failed to create file $scriptdir/$fname");
	print $fhandle "$pre\n";
	close $fhandle;
	$retstr = $retstr . "i preinstall=$scriptdir/$fname\n";
    }

    my $post = $package->get_block ("post");
    if (defined ($post)) {
	my $fhandle = "script" . ++$file_id;
	my $fname = $package->get_svr4_name() . ".postinstall";
	open $fhandle, ">$scriptdir/$fname" or
	    fatal ("failed to create file $scriptdir/$fname");
	print $fhandle "$post\n";
	close $fhandle;
	$retstr = $retstr . "i postinstall=$scriptdir/$fname\n";
    }

    my $preun = $package->get_block ("preun");
    if (defined ($preun)) {
	my $fhandle = "script" . ++$file_id;
	my $fname = $package->get_svr4_name() . ".preremove";
	open $fhandle, ">$scriptdir/$fname" or
	    fatal ("failed to create file $scriptdir/$fname");
	print $fhandle "$preun\n";
	close $fhandle;
	$retstr = $retstr . "i preremove=$scriptdir/$fname\n";
    }

    my $postun = $package->get_block ("postun");
    if (defined ($postun)) {
	my $fhandle = "script" . ++$file_id;
	my $fname = $package->get_svr4_name() . ".postremove";
	open $fhandle, ">$scriptdir/$fname" or
	    fatal ("failed to create file $scriptdir/$fname");
	print $fhandle "$postun\n";
	close $fhandle;
	$retstr = $retstr . "i postremove=$scriptdir/$fname\n";
    }

    my @classes = $package->get_classes ();
    foreach my $class_name (@classes) {
	next if not defined $class_name;
	next if $class_name eq "none";
	my $script = $package->get_class_script ($class_name, "iclass");
	if (not defined $script) {
	    my $err = $package->get_error ();
	    return undef if defined $err;
	} else {
	    open $fhandle, ">$scriptdir/i.$class_name" or
		fatal ("failed to create file $scriptdir/i.$class_name");
	    print $fhandle "$script";
	    close $fhandle;
	    $retstr = $retstr . "i i.$class_name=$scriptdir/i.$class_name\n";
	}
	$script = $package->get_class_script ($class_name, "rclass");
	if (not defined $script) {
	    my $err = $package->get_error ();
	    return undef if defined $err;
	} else {
	    open $fhandle, ">$scriptdir/r.$class_name" or
		fatal ("failed to create file $scriptdir/r.$class_name");
	    print $fhandle "$script";
	    close $fhandle;
	    $retstr = $retstr . "i r.$class_name=$scriptdir/r.$class_name\n";
	}
    }

    return $retstr;
}

sub get_file_mode ($) {
    my $fname = shift;

    $mode = (stat($fname))[2];
    if (not defined ($mode)) {
	print "WARNING: could not stat() $fname\n";
	return "0644";
    }
    return sprintf("%04o", $mode & 07777);
}

sub get_file_type ($) {
    my $fname = shift;

    if (-l $fname) {
	return "s";
    } elsif (-d $fname) {
	return "d";
    } elsif (-p $fname) {
	return "p";
    } elsif (-b $fname) {
	return "b";
    } elsif (-c $fname) {
	return "c";
    } elsif (-f $fname) {
	return "f";
    } else {
	return "-";
    }
}

# return the directory, relative to $basedir, where %doc files are
# placed for $package
sub get_docdir ($$) {
    my $package = shift;
    my $basedir = shift;

    my $docdir = $package->eval ("%_pkg_docdir");
    if ($docdir eq '%_pkg_docdir') {
	$docdir = $package->eval ("%{_datadir}/%{name}");
    }

    if (index ($docdir, $basedir) != 0) {
	$package->_set_error ("%_pkg_docdir ($docdir) is not under basedir $basedir");
	return undef;
    }

    $docdir = substr ($docdir, length ($basedir));
    $docdir =~ s/^\/*//;

    return $docdir;
}

# process a %doc file and return the proto line for $type: ips or svr4
sub get_doc_proto_line ($$$$;$) {
    my $type = shift;
    my $file = shift;
    my $fname = shift;
    my $basedir = shift;
    my $new_basedir = shift;

    my $package = $file->get_package ();
    my $docdir = get_docdir ($package, $basedir);
    return undef if not defined ($docdir);
    # now find the build directory:
    my $blddir = $package->eval ("%{_builddir}");
    my $bsdirname = $package->eval ('%{_build_src_dir_name}');
    if ($bsdirname eq '%{_build_src_dir_name}') {
	$bsdirname = $package->eval ('%name-%version');
    }

    my $doc_subdir = $file->get_doc_subdir();
    if (defined ($doc_subdir)) {
	$doc_subdir .= "/";
    } else {
	$doc_subdir = "";
    }

    if (! -f "$blddir/$bsdirname/$doc_subdir$fname") {
	return undef;
    }

    my $mydir = `pwd`;
    chomp ($mydir);
    # get the directory of $fname, in case we have something like
    # %doc foo/bar/COPYING
    my $fname_basedir = dirname ($fname);
    mkdir_p ("./$basedir/$docdir/$fname_basedir") or fatal ("Failed to create directory $mydir/$docdir/$fname_basedir");
    system ("rm -f './$basedir/$docdir/$fname_basedir/$fname'");
    system ("cp -fp '$blddir/$bsdirname/$doc_subdir$fname' './$basedir/$docdir/$fname_basedir'");
    if ($? != 0) {
	fatal ("ERROR: failed to copy $fname to $mydir/$basedir/$docdir/$fname_basedir");
	return undef;
    }
    my $compression = $file->get_compression ();
    if (defined ($compression)) {
	my $comp_retval;
	if ($compression eq 'compress') {
	    system ("rm -f './$basedir/$docdir/${fname}.Z'");
	    system ("/usr/bin/compress -f './$basedir/$docdir/$fname'");
	    $comp_retval = $?;
	    $fname .= ".Z";
	} elsif ($compression eq 'gzip') {
	    system ("rm -f './$basedir/$docdir/${fname}.gz'");
	    system ("/usr/bin/gzip -9 './$basedir/$docdir/$fname'");
	    $comp_retval = $?;
	    $fname .= ".gz";
	} elsif ($compression eq 'bzip2') {
	    system ("rm -f './$basedir/$docdir/${fname}.bz2'");
	    system ("/usr/bin/bzip2 -9 './$basedir/$docdir/$fname'");
	    $comp_retval = $?;
	    $fname .= ".bz2";
	}
	if ($comp_retval != 0) {
	    fatal ("ERROR: failed to $compression documentation file $mydir/$basedir/$docdir/$fname");
	    return undef;
	}
    }
	
    my $pkgbasedir = "$basedir/";
    $pkgbasedir =~ s/\/\/*/\//g;
    $pkgbasedir = substr ($pkgbasedir, 1);

    my $ips_pkgbasedir;
    if (defined ($new_basedir)) {
	$ips_pkgbasedir = "$new_basedir/";
	$ips_pkgbasedir =~ s/\/\/*/\//g;
	$ips_pkgbasedir = substr ($ips_pkgbasedir, 1);
    } else {
	$ips_pkgbasedir = $pkgbasedir;
    }

    $all_files{"$pkgbasedir$docdir/$fname"} = "$package";
    if ($type eq 'svr4') {
	return "f none $docdir/$fname=$pkgbasedir$docdir/$fname 0444 root bin";
    } elsif ($type eq 'ips') {
	my $svr_package = $file->get_package->get_svr4_name();
	my $svrfname = $file->get_package ()->eval ("%_pkgdir") . "/" . $svr_package . "/reloc/" . "$docdir/$fname";
	# FIXME: tag as a doc when facets are introduced
	return "file $svrfname mode=0444 owner=root group=bin path=\"$ips_pkgbasedir$docdir/$fname\"";
    } else {
	return undef;
    }
}

# FIXME: this is ugly as hell
sub get_proto_line ($$$$$$$$) {
    my $file = shift;
    my $class_name = shift;
    my $buildroot = shift;
    my $fname = shift;
    my $basedir = shift;
    my $def_mode = shift;
    my $def_user = shift;
    my $def_grp = shift;

    my $mode = $def_mode;
    my $user = $def_user;
    my $group = $def_grp;
    my $ghost = 0;

    my $type = get_file_type ($fname);

    if (($type eq '-') and defined ($file) and $file->is_doc ()) {
	# documentation file, goes under /usr/share/doc/<package name>
	# must be copied to $RPM_BUILD_ROOT from the build dir
	return get_doc_proto_line ('svr4', $file, $fname, $basedir);
    }

    if ($type eq '-') {
	if (defined ($file) and not $file->is_ghost ()) {
	    # we don't know what type of file it is
	    # or it doesn't exist
	    return undef;
	} else {
	    if (not defined ($file)) {
		# parent dir of a ghost
		$ghost = 1;
		$type = 'd';
	    } else {
		$ghost = 1;
		$type='g';
	    }
	}
    }

    if ($class_name ne 'none' and $type eq 'f' and $file->is_config ()) {
	$type = "e";
    }

    if ($type eq 'f' and defined ($file)) {
	if ($file->is_ghost ()) {
	    $type = 'v';
	} elsif ($file->is_config ()) {
	    $type = 'v';
	}
    }

    if (index ("/$fname", $basedir) != 0) {
	fatal ("file $fname is not under basedir $basedir");
    }	
    
    if ( "/$fname" eq $basedir) {
	fatal ("file $fname is the base directory, should not be listed in %files");
    }

    $basedir = "$basedir/";
    $basedir =~ s/\/\/*/\//g;
    $basedir = substr ("$basedir", 1);

    my $relpath = substr ($fname, length ($basedir));
    my $protoline;

    if ($def_mode eq '-' and $type ne 's') {
	if ($ghost) {
	    if ($type eq 'd') {
		$mode = '0755';
	    } else {
		$mode = '0644';
	    }
	} else {
	    $mode = get_file_mode ($fname);
	}
    }
    if ($def_user eq '-') {
	if ($ghost) {
	    $user = 'root';
	} else {
	    $user = getpwuid ((stat($fname))[4]);
	}
    }
    if ($def_grp eq '-') {
	if ($ghost) {
	    $group = 'root';
	} else {
	    $group = getgrgid ((stat($fname))[5]);
	}
    }

    if ($type eq 'f' or $type eq 'v' or $type eq 'e') {
	$protoline = "$type $class_name $relpath=$basedir$relpath $mode $user $group";
    } elsif ($type eq 'd') {
	$protoline = "$type $class_name $relpath $mode $user $group";
    } elsif ($type eq 'g') {
	$protoline = "v $class_name $relpath=/dev/null $mode $user $group";
    } elsif ($type eq 's') {
	my $linkpoint = readlink ($fname);
	my $buildroot_reg = $buildroot;
	$buildroot_reg =~ s/([\+\*\(\)\[\].\\])/\\$1/g;
	if ($linkpoint =~ /^$buildroot_reg/) {
	    fatal ("ERROR: /$fname is an absolute symlink that points to \$RPM_BUILD_ROOT");
	} elsif ($linkpoint =~ /^\//) {
	    print "WARNING: $fname is an absolute symlink\n";
	}
	if ($file->is_hardlink()) {
	    $protoline = "l none $relpath=$linkpoint";
	} else {
	    $protoline = "$type none $relpath=$linkpoint";
	}
    } elsif ($type =~ /(c|b)/) {
	fatal ('device special files not implemented');
    } else {
	fatal ('ASSERTION FAILED: get_proto_line');
    }

    return $protoline;
}

sub list_all_files ($) {
    my $dirname = shift;

    my $find_output = `find $dirname -print | grep -v "^$dirname\$"`;
    my @file_list = split /\n/, $find_output;

    return @file_list;
}

# Start filling up the manifest
# If the type is not supported write warning and return undef
sub get_ips_proto_line ($$$$$$$$$$$$) {
    my $file = shift;
    my $class_name = shift;
    my $buildroot = shift;
    my $fname = shift;
    my $basedir = shift;
    my $new_basedir = shift;
    my $def_mode = shift;
    my $def_user = shift;
    my $def_grp = shift;
    my $hardlink = shift;
    my $svr_package = shift;
    my $package = shift;

    my $mode = $def_mode;
    my $user = $def_user;
    my $group = $def_grp;

    # Delete double // from fname: example /usr//lib 
    $fname =~ s/\/+/\//g;
    my $type = get_file_type ($fname);
    my $line;
    
    debug_print "get_ips_proto_line $fname";
    if (($type eq '-') and defined ($file) and $file->is_doc ()) {
	# documentation file, goes under /usr/share/doc/<package name>
	# must be copied to $RPM_BUILD_ROOT from the build dir
	return get_doc_proto_line ('ips', $file, $fname, $basedir, $new_basedir);
    }

    if ( $type eq 'g' ) {
	print "Warning: Ghost files are *not* supported, yet\n";
	return undef;
    }

    if (($mode eq "-") and ($type ne "-")) {
	$mode = get_file_mode ($fname);
    }

    if ( $user eq '-' ) {
	$user = getpwuid ((stat($fname))[4]);
    }

    if ( $group eq '-' ) {
	$group = getgrgid ((stat($fname))[5]);
    }

    $basedir = "$basedir/";
    $basedir =~ s/\/\/*/\//g;
    $basedir = substr ("$basedir", 1);

    if (defined ($new_basedir)) {
	$new_basedir = "$new_basedir/";
	$new_basedir =~ s/\/\/*/\//g;
	$new_basedir = substr ("$new_basedir", 1);
    } else {
	$new_basedir = $basedir;
    }

    my $relpath;
    if ("$fname/" ne $basedir) {
	$relpath = substr ($fname, length ($basedir));
    } else {
	$relpath = "";
    }
    my $ipsfname = "$new_basedir$relpath";

    my $svrfname = $package->eval ("%_pkgdir") . "/" . $svr_package . "/reloc/" . $relpath;

    if ( $type eq 'f' and defined $file) {
	if ($ipsfname =~ /^(var|lib)\/svc\/manifest\/.*\.xml/) {
	    # an SMF manifest
	    # get a list of SMF service descriptions defined in the file
	    my @services = `/usr/sbin/svccfg inventory $svrfname 2>/dev/null`;
	    my $svc_values;
	    foreach my $svc (@services) {
		chomp($svc);
		print "Package defines SMF service $svc\n";
		if (defined ($svc_values)) {
		    $svc_values .= "," . $svc;
		} else {
		    $svc_values = $svc;
		}
	    }
	    if (defined ($svc_values)) {
		# add an opensolaris.smf.fmri attribute with all
		# smf services defined in the package
		my $smf_fmri = $package->get_meta("opensolaris.smf.fmri");
		if (defined ($smf_fmri)) {
		    $package->set_meta("opensolaris.smf.fmri",
				       $smf_fmri . "," . $svc_values);
		} else {
		    $package->set_meta("opensolaris.smf.fmri", $svc_values);
		}
	    }
	}
	$line = "file $svrfname mode=$mode owner=$user group=$group path=\"$ipsfname\"";
	# set preserve tag on config files
	if ($file->is_config()) {
	    my $preserve_option = $file->get_preserve;
	    $preserve_option = "true" unless defined ($preserve_option);
	    $line .= " preserve=\"$preserve_option\"";
	}
    } elsif ( $type eq 'd' ) {
	my $file1 = $fname;
	if ( not defined $file ) {
	    # a directory that was automatically added (not listed in %files)
	    $buildroot =~ s/([.\+\*\(\)\\\^\$])/\\$1/g;
	    $file1 =~ s/^$buildroot//;
	}
	$file1 =~ s/^$basedir/$new_basedir/;
	$file1 =~ s/^\/*//;
	$line = "dir mode=$mode owner=$user group=$group path=\"$file1\"";	
    } elsif ( $type eq 's' ) {
	# read the link target of the file in the proto area
	my $target = readlink ($fname);
	# Hardlinks are not tested in $RPM_BUILD_DIR, but they are used
	# only if spec file creator mark %files as hardlinks ...
	if ( defined $hardlink ){
	    $line = "hardlink path=\"$ipsfname\" target=\"$target\"";
	} else {
	    $line = "link path=\"$ipsfname\" target=\"$target\"";
	}
    }
    else {
	print "Warning: Unsupported object type $type on file $svrfname\n";
    }
	
    if ($type =~ /[fs]/) {
	# add additional tags specified with %ips_tag(foo)
	my $ref_tags = $file->ips_tags();
	foreach my $tagref (@$ref_tags) {
	    # expand macros in the ips_tags:
	    #   %@ or %{@} expands to the name of the file
	    #   %{basename:foo} expands to the basename of the foo
	    my $tag = "$tagref";
	    $tag =~ s/%{@}/$ipsfname/g;
	    $tag =~ s/%@/$ipsfname/g;
	    while ($tag =~ /%{basename:([^}]*)}/) {
		my $bname = basename($1);
		$tag =~ s/%{basename:([^}]*)}/$bname/;
	    }
	    # filter out duplicate tags
	    if (index(" $line "," $tag ") == -1) {
		$line .= " $tag"
	    }
	}
    }

    return $line;	
}

# Find all matches (in shell regexp file context)
# Return reference to array of files/dirs/links or whatever
sub find_all_matches($$) {
    my $fname = shift;
    my $build_path = shift;
    my $dirname = $build_path . $fname;
    #delete more duplicates of / - example /usr//lib
    $dirname =~ s/\/\/+/\//g;
    my $find_output = `find $dirname`;
    my @file_list = split /\n/, $find_output;
    
    # now remove all build_path prefixes 
    foreach $line (@file_list) {
	$line =~ s/^$build_path//;
	# Check if there is '/' at the beggining of path if not add it
	if ( $line !~ /^\// ) {
	    $line = "/$line";
	}
    }
    return \@file_list;
} 

my %system_proto_ips = 
    ("usr", "dir group=sys mode=0755 owner=root path=usr",
     "usr/bin", "dir group=bin mode=0755 owner=root path=usr/bin",
     "usr/lib", "dir group=bin mode=0755 owner=root path=usr/lib",
     "usr/share", "dir group=sys mode=0755 owner=root path=usr/share",
     "usr/share/aclocal", "dir group=other mode=0755 owner=root path=usr/share/aclocal",
     "usr/share/application-registry", "dir group=other mode=0755 owner=root path=usr/share/application-registry",
     "usr/share/applications", "dir group=other mode=0755 owner=root path=usr/share/applications",
     "usr/share/doc", "dir group=other mode=0755 owner=root path=usr/share/doc",
     "usr/share/gnome", "dir group=other mode=0755 owner=root path=usr/share/gnome",
     "usr/share/icons", "dir group=other mode=0755 owner=root path=usr/share/icons",
     "usr/share/lib", "dir group=sys mode=0755 owner=root path=usr/share/lib",
     "usr/share/locale", "dir group=other mode=0755 owner=root path=usr/share/locale",
     "usr/share/mime-info", "dir group=other mode=0755 owner=root path=usr/share/mime-info",
     "usr/share/pixmaps", "dir group=other mode=0755 owner=root path=usr/share/pixmaps",
     "usr/share/src", "dir group=sys mode=0755 owner=root path=usr/share/src",
     "etc", "dir group=sys mode=0755 owner=root path=etc",
     "opt", "dir group=sys mode=0755 owner=root path=opt",
     "var", "dir group=sys mode=0755 owner=root path=var",
     "kernel", "dir group=sys mode=0755 owner=root path=kernel",
     "lib", "dir group=bin mode=0755 owner=root path=lib");

sub get_system_proto_line($$) {
    my $dir = shift;
    my $ips = shift;

    if ($ips) {
	return $system_proto_ips{$dir};
    }

    return undef;
}

# Specify if we want a proto hash for SVr4 or IPS
sub get_proto_hash ($$$) {
    my $spec = shift;
    my $package = shift;
    my $do_ips = shift;

    if (defined ($do_ips)) {
	debug_print "Collecting IPS proto information";
    } else {
	debug_print "Collecting SVr4 proto information";
    }
      
    my $has_errors = 0;

    my @files = $package->get_files ($do_ips);
    my $error = $package->get_error ();
    my @defattr = $package->get_defattr ();
    if (defined ($error)) {
	print "ERROR: $error\n";
	return undef;
    }
    if (not @files) {
        my %empty_hash;
	return \%empty_hash;
    }
    
    my %file_info = ();
    my %default_dirs = ();

    my $cwd = `pwd`;
    chomp ($cwd);
    my $buildroot = $package->eval ("%buildroot");
    my $basedir = $package->get_tag ("sunw_basedir");
    if (not defined ($basedir) or ($basedir eq "")) {
	$basedir = "/";
    }
    $basedir =~ s/(.)\/*$/$1/;

    my $orig_basedir = $basedir;
    my $basedir_opts = $package->get_tag_opts ('SUNW_BaseDir');
    if (defined ($basedir_opts)) {
	if ($basedir_opts =~ /\(relocate_from[:=](.+)\)/) {
	    $basedir = $1;
	}
    }
	
    chdir ($buildroot);

    foreach my $file (@files) {
	next if not $file;
	my $fn = "$file";
	# remove duplicate /'s, e.g. /etc///passwd
	$fn =~ s/^\/+//g;
	# remove /'s and whitespace from the end of the file name
	# except if fn is /
	$fn =~ s/(.)\/*\s*$/$1/;
	my $class_name = $file->get_class ();
	my @file_list;
	if (-f $fn) {
	    @file_list = ($fn);
	} else {
	    if ($file->is_doc () and not "$file" =~ /^\//) {
		# search for doc files in the build dir
		my $blddir = $package->eval ("%{_builddir}");
		my $bsdirname = $package->eval ('%{_build_src_dir_name}');
		if ($bsdirname eq '%{_build_src_dir_name}') {
		    $bsdirname = $package->eval ('%name-%version');
		}
		my $doc_subdir = $file->get_doc_subdir();
		if (defined ($doc_subdir)) {
		    $doc_subdir .= "/";
		} else {
		    $doc_subdir = "";
		}

		chdir ("$blddir/$bsdirname/$doc_subdir");
		@file_list = glob ($fn);
		chdir ($buildroot);
	    } else {
		@file_list = glob ($fn);
	    }
	}
	if ((not @file_list) and (not $file->is_ghost())) {
	    message ("File not found by glob: $buildroot$file");
	    $has_errors = 1;
	}

	my @attribs = $file->get_attributes ();
	my @defattribs = $file->get_defattributes ();
	my @rec_list = ();
	
	foreach my $fname (@file_list) {
	    if ($file->is_recursive()) {
		if ($file->is_doc and not "$file" =~ /^\//) {
		    # a directory in the source tree that contains doc files
		    my $blddir = $package->eval ("%{_builddir}");
		    my $bsdirname = $package->eval ('%{_build_src_dir_name}');
		    if ($bsdirname eq '%{_build_src_dir_name}') {
			$bsdirname = $package->eval ('%name-%version');
		    }
		    my $doc_subdir = $file->get_doc_subdir();
		    if (defined ($doc_subdir)) {
			$doc_subdir .= "/";
		    } else {
			$doc_subdir = "";
		    }

		    chdir ("$blddir/$bsdirname/$doc_subdir");
		    if (-d $fname){
			my @files_in_dir = list_all_files ($fname);
			@rec_list = (@rec_list, @files_in_dir);
			$fname = "";
		    }
		    chdir ($buildroot);
		} else {
		    if (-d $fname) {
			my @files_in_dir = list_all_files ($fname);
			@rec_list = (@rec_list, @files_in_dir);
		    }
		}
	    }
	}
    
	my @all_file_list = (@file_list, @rec_list);
	foreach my $fname (@all_file_list) {
	    next if ($fname eq "");
	    if ($file->is_excluded ()) {
		$file_info{$fname} = "!exclude";
		next;
	    }
	    if (defined ($file_info{$fname}) and $file_info{$fname} ne "!exclude") {
		message ("File listed twice: $fname");
		$has_errors = 1;
	    }
	    
	    if (not defined ($file_info{$fname}) or $file_info{$fname} eq "!exclude") {
		# Assume that we are going to use the defattrs;
                # we'll fixup later
                my @attribsToUse = @defattribs;
                my $mode = $attribsToUse[0];
                # We use the directory mode if this 
                # is a directory (and we have a default directory
                # mode)
                if ( -d $buildroot . '/' . $fname) {
                    if (exists $attribsToUse[3]) {
                        $mode = $attribsToUse[3];
                    }
                }
		
                # We use the attribs (rather than the defattribs)
                # if this is the file listed in %files AND
                # we have attributes
                if (grep $fname eq $_, @all_file_list) {
                    if (@attribs) {
                        @attribsToUse = @attribs;
                        $mode = $attribs[0];
                    }
                }
			
		my $pline;
		if (defined $do_ips) {
		    my $hardlink = undef;
		    
		    # FIXME: $fname should be used and not $file!
		    # 	but $fname wrong data type ( string?)
		    if ($file->is_hardlink()) {
			$hardlink = 1;
		    }
		    
		    if ( not defined $file_info{$fname} ) {
			$pline = undef;
			$pline = get_ips_proto_line ($file,
						     $class_name,
						     $buildroot,
						     $fname, 
						     $basedir,
						     $orig_basedir,
						     $mode,
						     $attribsToUse[1],
						     $attribsToUse[2],
						     $hardlink,
						     $package->get_svr4_name(),
						     $package);
			if (not defined ($pline)) {
			    message ("IPS: File not found by glob: $buildroot/$fname");
			    $has_errors = 1;
			}
			$file_info{$fname} = $pline;
		    }
		} else {
		    # Now collect for SVr4 packages
		    my $pline = get_proto_line ($file,
						$class_name,
						$buildroot,
						$fname, 
						$basedir,
						$mode,
						$attribsToUse[1],
						$attribsToUse[2]);
		    if (not defined ($pline)) {
			$has_errors = 1;
			if ($file->is_doc ()) {
			    message ("Documentation (%doc) file not found: $fname");
			} else {
			    message ("File not found by glob: $buildroot/$fname");
			}
		    }
		    $file_info{$fname} = $pline;
		    if (defined ($all_files{$fname}) and
			substr ($pline, 0, 1) ne "d" and
			$pline ne "!exclude") {
			my $err_msg;
			if ($file->is_doc ()) {
			    $err_msg = "documentation file $fname is included in both $package and $all_files{$fname}";
			} else {
			    $err_msg = "$fname is included in both $package and $all_files{$fname}";
			}
			if ($package->eval ('%_duplicate_files_terminate_build') eq 1) {
			    print "ERROR: $err_msg\n";
			    $package->_set_error ("$err_msg");
			    $has_errors = 1;
			} else {
			    print "WARNING: $err_msg\n";
			}
		    }
		}
		# automatically adding all missing parent dirs
		my $parent_dir = $fname;
		if ($file->is_doc and not "$file" =~ /^\//) {
		    # %doc files may not include the docdir, only the file name
		    # so we prepend the name of the docdir otherwise it wouldn't
		    # be found in $RPM_BUILD_ROOT
		    my $docdir = get_docdir ($package, $basedir);
		    if (not defined ($docdir)) {
			$has_errors = 1;
		    } else {
			$parent_dir = "$basedir/$docdir/$fname";
			# delete leading /s
			$parent_dir =~ s/^\/+//;
		    }
		}
		$parent_dir =~ s/\/[^\/]+$//;
		while ($parent_dir ne "" and
		       not defined ($file_info{$parent_dir}) and
		       not defined ($default_dirs{$parent_dir})) {
		    # SVr4 packages need to add parent dirs up to $basedir,
		    # bug IPS packages have to go all the way to /
		    if (not defined ($do_ips) and "/$parent_dir" eq "$basedir") {
			last;
		    }

		    my $dirmode = $defattr[3];
            	    if (not defined $dirmode or $dirmode eq '-') {
			$dirmode = $defattr[0]; # fall back to old behaviour
		    }
		    my $pline = get_system_proto_line ($parent_dir, $do_ips);
		    if (not defined $pline) {
			if (defined $do_ips) {
			    $pline = get_ips_proto_line(undef,
							"none",
							$buildroot,
							$parent_dir,
							$basedir,
							$orig_basedir,
							$dirmode,
							$defattr[1],
							$defattr[2],
							undef,
							$package->get_svr4_name(),
							$package);
			} else {
			    $pline = get_proto_line (undef,
						     "none",
						     $buildroot,
						     $parent_dir,
						     $basedir,
						     $dirmode,
						     $defattr[1],
						     $defattr[2]);
			}
		    }
		    if (defined ($pline)) {
			$default_dirs{$parent_dir} = $pline;
		    } else {
			last;
		    }
		    $parent_dir =~ s/\/[^\/]+$//;
		}
	    }
    	}
    }
    chdir ($cwd);

    foreach my $dirname (keys %default_dirs) {
	if (not defined ($file_info{$dirname})) {
	    $file_info{$dirname} = $default_dirs{$dirname}
	}
    }

    if ($has_errors == 1) {
	return undef;
    } else {
	return \%file_info;
    }
}

sub make_solaris_pkg ($$) {
    my $spec = shift;
    my $package = shift;

    my $pkginfo_proto = make_pkginfo ($spec, $package);
    my $dep_proto = make_depend ($spec, $package);
    my $scr_proto = make_scripts ($spec, $package);
    return 0 if not defined $scr_proto;
    my $copyright = make_copyright ($spec, $package);

    my $files_ref = get_proto_hash ($spec, $package, undef);
    if (not defined ($files_ref)) {
	if ($spec->has_error ()) {
	    print ("pkgbuild: " . $spec->get_error () . "\n");
	}
	exit (1);
    }
    my %files = %$files_ref;
    foreach my $file (keys %files) {
	next if $file eq "!exclude";
	$file =~ s/^\/+//;
	$all_files{$file} = "$package";
    }
    if (not %files) {
	print "WARNING: empty package: $package\n";
    }

    my $fhandle = "proto" . ++$file_id;

    my $protodir = $spec->eval ("%_pkgmapdir") . "/proto";
    my $fname = $package->get_svr4_name() . ".proto";
    open $fhandle, ">$protodir/$fname" or
	fatal ("failed to create file $protodir/$fname");

    print $fhandle $pkginfo_proto;
    print $fhandle $dep_proto;
    print $fhandle $scr_proto;
    if (defined $copyright) {
	print $fhandle $copyright;
    }
    foreach my $fname (sort (keys %files)) {
	next if not $fname;
	next if $files{$fname} eq "!exclude";
	print $fhandle $files{$fname};
	print $fhandle "\n";
    }
    close ($fhandle);

    my $pkgdir = $spec->eval ("%_pkgdir");
    my $buildroot = $package->eval ("%buildroot");
    system ("/usr/bin/pkgmk -o -r $buildroot -d $pkgdir -f $protodir/$fname");
    my $retval = $?;
    if ($retval) {
	return 0;
    }

    if ($pkgformat eq "datastream") {
	my $inst = $package->get_tag ('SUNW_Pkg');
	$inst = "$package" unless $inst;
	my $version = $package->get_tag ('Version');
	my $dsname = "${inst}-${version}.${arch}.pkg";
	system ("/usr/bin/pkgtrans -o -s $pkgdir $pkgdir/$dsname $inst");
	$retval = $?;
	if (not $retval) {
	    system ("rm -rf $pkgdir/$inst");
	}
	debug_print "Wrote: $pkgdir/$dsname\n";
    }

    return (not $retval);
}


sub _uniq (@) {
    my @arr = @_;

    my %h;

    foreach my $elem (@arr) {
	next if not defined $elem;
	$h{$elem} = 1;
    }
    return keys %h;
}


# Write dependency info for pkgsend (without pkgsend command)
# The first agument contain reference to array - at the end of this
# array
sub make_ips_dependency ($$$) {
    my $ref_lines = shift;
    my $spec = shift;
    my $package = shift;
    
    my @packages = $spec->get_packages();
    my @deps;
    my @autodeps = ();
    my %autodep_hash;

    if ($package->eval ('%_use_internal_dependency_generator') eq "1") {
	print "Looking for dependencies using the internal dependency generator\n";
	my $filelist_ref = $package->get_filelist ();
	if (@$filelist_ref) {
	    my $tmpfile = `/usr/bin/mktemp /tmp/pkgbuild-filelist-XXXX` or
		fatal ("mktemp failed");
	    chomp ($tmpfile);
	    open FILELIST, ">>$tmpfile" or
		fatal ("failed to open temporary file $tmpfile");
	    my $buildroot = $package->eval ("%buildroot");
	    foreach my $fname (@$filelist_ref) {
		print FILELIST "/$fname\n";
	    }
	    close FILELIST;
	    my @autodeps = `/usr/lib/pkgbuild-1.3.104/ips-dependency-generator -R '$buildroot' -f $tmpfile` or
		print "No dependencies discovered\n";
	    `rm -f $tmpfile`;
	    my $ips_name = $package->get_ips_name ();
	    foreach my $pkgname (@autodeps) {
		chomp ($pkgname);
		my $versionless = $pkgname;
		$versionless =~ s/@.*//;
		next if $versionless eq $ips_name;
		print "  dependency discovered: $pkgname\n";
		$autodep_hash{$versionless} = $pkgname;
	    }
	} else {
	    print "No files to analyse\n";
	}
    }

    my $ref_ips_name = $package->get_ips_name ();
    foreach my $pkg (@packages) {
	my $ips_name = $pkg->get_ips_name ();
	next if ($ips_name ne $ref_ips_name);
	my @pkg_deps = $pkg->get_array('requires');
	foreach my $pkg_dep (@pkg_deps) {
	    my $dep_pkg = $spec->find_package_by_svr4_name ($pkg_dep);
	    # the package is defined in the same spec file
	    if (defined ($dep_pkg)) {
		my $dep_pkg_ips_name = $dep_pkg->get_ips_name ();
		# the IPS name is the same as the package
		# we are contruction the manifest for. so
		# we don't need to add a dependency
		if ($dep_pkg_ips_name eq $ref_ips_name) {
		    message ("omitting dependency $pkg_dep as it is a dependency on the same IPS package");
		    next;
		}
	    }
	    push (@deps, $pkg_dep);
	}
    }
    my @dep_lines = ();
    foreach my $dep (@deps) {
	my $version_spec = $dep;
	$version_spec =~ s/[^\s><=]+\s*//;
	my $any_version = 0;
	$dep =~ s/([^\s><=]+).*/$1/;

	# FIXME: we're only checking for =*, but we should process all
	# version specifications
	if ($version_spec =~ /=\s*\*/) {
	    $any_version = 1;
	}

	my $pkg = $spec->find_package_by_pkg_name ($dep);
	if (defined ($pkg)) {
	    my $ips_dep = $pkg->get_ips_name();
	    my $versionless = $ips_dep;
	    $versionless =~ s/@.*//;
	    delete ($autodep_hash{$versionless});
	    my $minversion;
	    if ($version_spec =~ />=\s*(\S+)/) {
		# check if the version exists
		$minversion = $1;
		print "Verifying dependency $versionless\@$minversion\n";
		my $cmdout = `pkg info -r "$versionless\@$minversion"`;
		if ($? != 0) {
		    # version does not exist
		    print "WARNING: package $versionless\@$minversion does not exist:\n$cmdout";
		    print "WARNING: ignoring minimum version specification\n";
		    $minversion = undef;
		}
	    }
	    if ($any_version) {
		$ips_dep = $versionless;
	    } elsif (defined ($minversion)) {
		$ips_dep = "$versionless\@$minversion";
	    }
	    push @dep_lines, "depend fmri=$ips_dep type=require";
	    next;
	}
	my $ips_dep = $pkgdb->get_ips_pkgname ($dep);
	if (defined ($ips_dep)) {
	    my $versionless = $ips_dep;
	    $versionless =~ s/@.*//;
	    delete ($autodep_hash{$versionless});
	    my $minversion;
	    if ($version_spec =~ />=\s*(\S+)/) {
		# check if the version exists
		$minversion = $1;
		print "Verifying dependency $versionless\@$minversion\n";
		my $cmdout = `pkg info -r "$versionless\@$minversion"`;
		if ($? != 0) {
		    # version does not exist
		    print "WARNING: package $versionless\@$minversion does not exist:\n$cmdout";
		    print "WARNING: ignoring minimum version specification\n";
		    $minversion = undef;
		}
	    }
	    if ($any_version) {
		$ips_dep = $versionless;
	    } elsif (defined ($minversion)) {
		$ips_dep = "$versionless\@$minversion";
	    } else {
		$ips_dep =~ s/@([^,]+),[^-]+-(\S+)/\@$1-$2/;
	    }
	    push @dep_lines, "depend fmri=$ips_dep type=require";
	} else {
	    print "WARNING: omitting $dep from the IPS manifest\n";
	}
    }
    # deal with obsolete tags
    # these must specify a version but that version need not exist
    # = * can be specified for a versionless depend line
    foreach my $pkg (@packages) {
	my $ips_name = $pkg->get_ips_name ();
	next if ($ips_name ne $ref_ips_name);
	my @pkg_obss = $pkg->get_array('renamed_to');
	foreach my $pkg_obs (@pkg_obss) {
	    my $version_spec = $pkg_obs;
	    $version_spec =~ s/[^\s><=]+\s*//;
	    $pkg_obs =~ s/([^\s><=]+).*/$1/;

	    my $any_version = 0;
	    if ($version_spec =~ /=\s*\*/) {
		$any_version = 1;
	    }

	    if (not $any_version) {
		my $minversion;
		if ($version_spec =~ /(>=|=)\s*(\S+)/) {
		    $minversion = $2;
		}
		if (not defined ($minversion) or $minversion eq "") {
		    print "WARNING: invalid version specification in Renamed_To line: $pkg_obs\n";
		    next;
		}
		$ips_dep = "$pkg_obs\@$minversion";
		push @dep_lines, "depend fmri=$ips_dep type=require";
	    } else {
		push @dep_lines, "depend fmri=$pkg_obs type=require";
	    }
	}
    }
    foreach my $ips_dep (keys %autodep_hash) {
	push @dep_lines, "depend fmri=$autodep_hash{$ips_dep} type=require";
    }
    push @$ref_lines, _uniq (@dep_lines)
}

# Add open transaction line - with pkgsend command
sub open_ips_transaction($$;$) {
    my $ref_lines = shift;
    my $package = shift;
    my $src = shift;

    my $src_name = "";
    my $name = $package->get_ips_name();
    
    my $ips_vendor_version = $package->get_value_of ("ips_vendor_version");
    my $ips_component_version = $package->get_value_of ("ips_component_version");
    my $ips_build_version = $package->get_value_of ("ips_build_version");
    my $version = $package->eval("${ips_component_version},${ips_build_version}-${ips_vendor_version}");

    my $esc_name = $package->get_ips_name();
    $esc_name =~ s/\//%2F/g;
    my $manifest = $package->eval ("%_pkgmapdir") . "/manifests/" .
	$esc_name . ".manifest";
    # is it a source package?
    if (defined ($src)) {
	$esc_name = $package->get_name();
	$esc_name =~ s/\//%2F/g;
	$manifest = $package->eval ("%_pkgmapdir") . "/manifests/" .
	    $esc_name . "_src.manifest";
	$name = $package->eval ("%{?ips_sourcepackage}%{!?ips_sourcepackage:${name}/src}");
    }

    if (defined ($src)) {
	push (@$ref_lines, "export PKG_REPO=\${PKGBUILD_SRC_IPS_SERVER:-\${PKGBUILD_IPS_SERVER:-$ips_server}}");
    } else {
	push (@$ref_lines, "export PKG_REPO=\${PKGBUILD_IPS_SERVER:-$ips_server}");
    }
    push (@$ref_lines, "eval `pkgsend open $name\@$version` || exit 1");
    push (@$ref_lines, "pkgsend include $manifest || exit 2");
} 

# Add lincense action
sub add_ips_license($$) {
    my $ref_lines = shift;
    my $package = shift;
    
    my $svr4_name = $package->get_svr4_name ();
    my $license_file= $package->eval ("%_pkgdir") . "/" . $svr4_name . "/install/copyright";

    return if not -f $license_file;

    # renamed and obsolete packages cannot have license actions
    my $is_renamed = $package->get_meta("pkg.renamed");
    return if (defined ($is_renamed) and 
	     ($is_renamed eq "true" or $is_renamed eq "1"));
    my $is_obsolete = $package->get_meta("pkg.obsolete");
    return if (defined ($is_obsolete) and 
	     ($is_obsolete eq "true" or $is_obsolete eq "1"));
    
    my $license = $package->get_tag ("license");
    if (not defined ($license)) {
	# License is the new name for the Copyright tag
	$license = $package->get_tag ("copyright");
    }
    if (not defined ($license)) {
	$license = "unknown";
    }
    push (@$ref_lines, "license $license_file license=\"$license\"");
}

# Add summary line
# src_fmri == "-src" means this is the source package
sub add_ips_summary($$;$) {
    my $ref_lines = shift;
    my $package = shift;
    my $src_fmri = shift;

    my $summary = $package->get_tag("summary");
    $summary = "$package" unless defined ($summary);

    # make a hash the combines the various meta tags in all %package that
    # are used to create this IPS packages (the ones that have the same name)
    my %bighash;

    my $spec = $package->get_spec();
    my @packages = $spec->get_packages ();
    my $ips_name = $package->get_ips_name();
    foreach my $pkg (@packages) {
	# is this the same IPS package as $package?
	next if ($pkg->get_ips_name() ne $ips_name);

	my $meta_hash = $pkg->get_meta_hash();
	foreach my $key (keys %{$meta_hash}) {
	    if (defined $bighash{$key}) {
		next if ($bighash{$key} eq $$meta_hash{$key});
		$bighash{$key} .= ",\"" . $$meta_hash{$key} . "\"";
	    } else {
		$bighash{$key} = $$meta_hash{$key};
	    }
	}
    }

    if (not defined ($bighash{'pkg.description'})) {
	my $desc = $package->eval ("%DESC");
	if ($desc ne "%DESC") {
	    $bighash{'pkg.description'} = "\"$desc\"";
	}
    }
    if (not defined ($bighash{'pkg.summary'})) {
	$bighash{'pkg.summary'} = "\"$summary\"";
    }
    if (not defined ($bighash{'info.upstream_url'})) {
	my $upstream_url = $package->get_tag("url");
	if (defined ($upstream_url)) {
	    $bighash{'info.upstream_url'} = "\"$upstream_url\"";
	}
    }

    my $group = $package->get_tag("group");
    my $classification_set = 0;

    my $is_renamed = 0;
    my $is_obsolete = 0;
    if (defined ($bighash{"pkg.renamed"}) and
		 ($bighash{"pkg.renamed"} eq "true" or
		  $bighash{"pkg.renamed"} eq "1")) {
	$is_renamed = 1;
    }
    if (defined ($bighash{"pkg.obsolete"}) and
		 ($bighash{"pkg.obsolete"} eq "true" or
		  $bighash{"pkg.obsolete"} eq "1")) {
	$is_obsolete = 1;
    }

    foreach my $meta (keys %bighash) {
	# we want to exclude certain attributes from source packages
	if (defined ($src_fmri)) {
	    next if $meta eq "pkg.renamed";
	}
	# certain attributes should not be in renamed/obsolete packages
	if ($meta eq "pkg.description" or $meta eq "pkg.summary") {
	    next if $is_renamed or $is_obsolete;
	}
	if ($meta eq "info.classification" and ($is_renamed or $is_obsolete)) {
	    # no classification in renamed/obsolete pkgs
	    $classification_set = 1;
	    next;
	}

	# handle info.classification separately, as there may be more than one
	# and they need to be in the same action
	my $val = $bighash{$meta};
	my @values;
	if ($val =~ /^"(.*)"$/) {
	    # the value is quoted
	    @values = ($1);
	} else {
	    # split values at commas, unless comma is escaped
	    while ($val =~ /^(.*[^\\]),\s*(.*)/) {
		$val = $1;
		my $v0 = $2;
		if ($v0 =~ /^"(.*)"$/) {
		    $v0 = $1;
		}
		if ($v0 ne "") {
		    unshift (@values, $v0);
		}
	    }
	    if ($val =~ /^"(.*)"$/) {
		$val = $1;
	    }
	    if ($val ne "") {
		unshift (@values, $val);
	    }
	}
        map s/([^\\]|^)"/$1\\"/g, @values;
	map s/\\,/,/g, @values;
	my $val_str = "";
	map $val_str .= " value=\"$_\"", @values;
	# info.classification Meta tag seen
	$classification_set = 1 if $meta eq "info.classification";
	if ($meta eq "info.classification" and defined($group)) {
	    # there is also a Group tag
	    if (defined $group) {
		push (@$ref_lines, "set name=$meta$val_str value=\"org.rpm:" . $group . "\"");
	    }
	} else {
	    push (@$ref_lines, "set name=$meta$val_str");
	}
    }

    # no meta tag sets info.classification but there is a Group tag
    if (not $classification_set and defined ($group)) {
	push (@$ref_lines, "set name=info.classification value=\"org.rpm:" . $group . "\"");
    }

    push (@$ref_lines, "set name=build.tool value=\"pkgbuild\"");
    push (@$ref_lines, "set name=net.sourceforge.pkgbuild,version value=\"1.3.104\"");
    if (defined ($src_fmri) and $src_fmri ne "-src") {
	# this is not the source package itself
	if (not $src_ips_server =~ /\/$/) {
	    $src_ips_server .= "/";
	}
	push (@$ref_lines, "set name=build.source_uri value=\"${src_ips_server}p5i/0/" . url_escape ("$src_fmri") . "\"");
	# FIXME: build date?  e.g. build.date
    }

    if (not defined($src_fmri) or $src_fmri ne "-src") {
	if (@predefines) {
	    my $values = "";
	    foreach my $predef (@predefines) {
		$values .= " value=\"$predef\"";
	    }
	    push (@$ref_lines, "set name=net.sourceforge.pkgbuild,defines$values");	    
	}
    }

    # add pointers sources specified by URLs and not listed in NoSource
    my @sources = $package->get_spec()->get_public_sources ();
    my $source_values = "";
    foreach my $src (@sources) {
	next if (not $src =~ /^(http|https|ftp):\/\//);
	$source_values .= " value=\"$src\"";
    }
    if ($source_values ne "") {
	push (@$ref_lines, "set name=info.source_url$source_values");
    }
}

sub add_ips_legacy($$$;$) {
    my $ref_lines = shift;
    my $spec = shift;
    my $package = shift;
    my $src = shift;

    my @packages = $spec->get_packages ();
    my $ips_name = $package->get_ips_name();
    my %legacy_pkgs = ();
    my $pkg_arch = get_pkg_arch($package);
    foreach my $pkg (@packages) {
	my $need_legacy = $pkg->get_tag("ips_legacy");
	next if (defined ($need_legacy) and ($need_legacy eq "false" or
					     $need_legacy eq "0"));
	# is this the same IPS package as $package?
	next if ($pkg->get_ips_name() ne $ips_name);
	# PKG=$pkgname
	my $pkgname = $pkg->get_svr4_name();
	if (defined ($src)) {
	    my $src_pkg_name = $spec->get_value_of ("sourcepackage");
	    if (defined $src_pkg_name) {
		$pkgname = $src_pkg_name;
	    } else {
		$pkgname .= "-src";
	    }
	}
	# has this legacy action been added yet?
	next if defined($legacy_pkgs{$pkgname});
	$legacy_pkgs{$pkgname} = 1;
	my $summary = $pkg->get_tag ('summary');
	$summary = "$pkg" unless defined ($summary);
	# NAME=$desc
	# DESC=$desc
	my $desc = $pkg->get_tag ('sunw_desc');
	$desc = $summary unless defined ($desc);
	$desc = "$pkg" unless defined ($desc);
	if (defined ($src)) {
	    $summary = "Source package for $summary";
	    $desc = "Source package for $summary";
	}
	# CATEGORY=$category
	my $category = $pkg->get_tag ('sunw_category');
	if (not defined ($category)) {
	    $category = "application";
	}
	# VENDOR=$vendor
	my $vendor = $pkg->get_tag ('vendor');
	if (defined ($vendor)) {
	    $vendor = "vendor=\"$vendor\"";
	} else {
	    $vendor = "";
	}
	# HOTLINE=$hotline
	my $hotline = $pkg->get_tag ('sunw_hotline');
	$hotline = "Please contact your local service provider" 
	    unless defined ($hotline);
	# VERSION=$version,REV=$rev
	my $version = $pkg->get_tag ('version');
	my $rev = $pkg->get_tag ('sunw_rev');
	if (not defined $rev) {
	    $rev = `date +%Y.%m.%d.%H.%M.%S`;
	}
	chomp ($rev);

	$desc =~ s/"/\\"/g;
	$hotline =~ s/"/\\"/g;
	push (@$ref_lines, "legacy arch=$pkg_arch category=$category desc=\"$desc\" hotline=\"$hotline\" name=\"$desc\" pkg=$pkgname $vendor version=$version,REV=$rev");

	if (defined ($src)) {
	    # only add 1 legacy action in a source package,
	    # not one for each subpackage.
	    last;
	}
    }
    # see http://blogs.sun.com/barts/?cat=packaging+and+patching&date=20090204
    $pkg_arch =~ s/,/ value=/;
    push (@$ref_lines, "set name=variant.arch value=$pkg_arch");
}

# Add close transaction
sub close_ips_transaction($) {
    my $ref_lines = shift;
    my @lines = @$ref_lines;
    
    push (@$ref_lines , "pkgsend close || exit 3");
}

my @autotag_data = (["etc/gconf/schemas/.*\.(schemas|entries)",
		     "svc:/application/desktop-cache/gconf-cache:default",
		     "SUNWdesktop-cache"],
		    ["usr/share/icons/.*\.(png|svg|icon)",
		     "svc:/application/desktop-cache/icon-cache:default",
		     "SUNWdesktop-cache"],
		    ["usr/share/icons/.*/cursors/.*",
		     "svc:/application/desktop-cache/icon-cache:default",
		     "SUNWdesktop-cache"],
		    ["usr/lib/.*gtk-2.0/.*/immodules/.*\.so",
		     "svc:/application/desktop-cache/input-method-cache:default",
		     "SUNWdesktop-cache"],
		    ["usr/share/mime/packages/.*\.xml",
		     "svc:/application/desktop-cache/mime-types-cache:default",
		     "SUNWdesktop-cache"],
		    ["usr/lib/.*gtk-2.0/.*loaders/.*\.so",
		     "svc:/application/desktop-cache/pixbuf-loaders-installer:default",
		     "SUNWdesktop-cache"],
		    ["usr/share/applications/.*\.desktop",
		     "svc:/application/desktop-cache/desktop-mime-cache:default",
		     "SUNWdesktop-cache"],
		    ["usr/X11/lib/X11/fonts/.*\.(ttf|pcf|pcf\.gz)",
		     "svc:/application/font/fc-cache:default",
		     "SUNWfontconfig"],
		    ["usr/share/fonts/.*\.(ttf|pcf|pcf\.gz)",
		     "svc:/application/font/fc-cache:default",
		     "SUNWfontconfig"],
		    ["(var|lib)/svc/manifest/.*\.xml",
		     "svc:/system/manifest-import:default"]
    );

# add automatic tags for files at known locations, e.g. .desktop files,
# smf manifests, gconf schemas, etc.
sub autotag ($$$) {
    my $ref_lines = shift;
    my $fname = shift;
    my $pline = shift;

    foreach my $aref (@autotag_data) {
	my ($path, $fmri, $dep) = @$aref;
	if ($fname =~ /^${path}$/) {
	    if (not $pline =~ /restart_fmri="*${fmri}"*/) {
		$pline .= " restart_fmri=$fmri";
	    }
	    next if not defined ($dep);
	    my $ips_dep = $pkgdb->get_ips_pkgname ($dep);
	    if (defined ($ips_dep)) {
		if(not grep { "$_" eq "depend fmri=$ips_dep type=require" } @$ref_lines) {	
		    # add dependency if it's not already there
		    push(@$ref_lines, "depend fmri=$ips_dep type=require");
		}
	    }
	}
    }
    return $pline;
}

# Create file list from package with tag for subpackages for pkgsend command
sub make_ips_package ($$$$$) {
    my $spec = shift;
    my $package = shift;
    my $ref_lines = shift;
    my $all_files_ref = shift;
    my $tag = shift;
    
    if (defined $tag) {
	if ($tag =~ /(devel|doc|l10n)/) {
	    # FIXME: disable automatic tagging for now
	    # will become facets in the future
	    $tag = "";
	} else {
	    $tag = "";
	}
    } else {
	$tag = "";
    }
    
    my $files_ref = get_proto_hash ($spec, $package, 1);
    if (not defined ($files_ref)) {
	exit (1);
    }
    my %files = %$files_ref;
    my @filelist = ();
    foreach my $f (keys %files) {
	next if $files{$f} eq "!exclude";
	push(@filelist, $f);
    }
    $package->set_filelist (\@filelist);
    my $pline;
    my $do_autotag = $spec->eval('%{?_use_ips_autotag}%{!?_use_ips_autotag:0}');
    foreach my $file (keys %files) {
	$pline = $files{$file};
	next if $files{$file} eq "!exclude";
	if ($do_autotag) {
	    $pline = autotag($ref_lines, $file, $pline);
	}
	push(@$ref_lines, $pline . $tag) 
	    unless defined $$all_files_ref{$file};
	# only include each file in the manifest once otherwise
	# we get an error during installation
	$$all_files_ref{$file} = 1;
    }
    if (not %files) {
	print "WARNING: no files in package: $package\n";
    }
}

# Prepare pkgsend lines, which add files of package to ips repository
sub make_ips_files ($$$) {
    my $ref_lines = shift;
    my $spec = shift;
    my $package = shift;

    my @packages = $spec->get_packages ();
    my $tag;
    my %all_files_in_manifest = ();
    foreach $pkg (@packages) {
	$tag = $pkg->get_pkg_tag ();
	next if $package->get_ips_name() ne $pkg->get_ips_name();
	debug_print "making package $pkg";
	make_ips_package($spec, $pkg, $ref_lines, \%all_files_in_manifest, $tag);
    }
}

# add actions listed in the %actions section, if defined
sub make_ips_actions($$) {
    my $ref_lines = shift;
    my $package = shift;
    
    my $actions = $package->{_actions};
    
    foreach $action_string (@$actions) {
        push(@$ref_lines, $action_string);
    }
}

# Create infrastructure for IPS packages
sub create_ips_packages ($$) {
    my $spec = shift;
    my $src_fmri = shift;

    my @packages = $spec->get_packages ();
    foreach $package (@packages) {
	if (not $package->has_files(1)) {
	    my $make_empty = $package->get_value_of("pkgbuild_make_empty_package");
	    next if not defined ($make_empty);
	    next if ($make_empty ne "1" and $make_empty ne "true");
	}
	create_ips_package ($spec, $package, $src_fmri) 
	    unless $package->is_subpkg ();
    }
}

sub create_ips_package ($$$) {
    my $spec = shift;
    my $package = shift;
    my $src_fmri = shift;

    debug_print "Publishing ips package";

    my @pkg_lines;
    my @manifest_lines;
    debug_print "Opening ips_transaction";
    open_ips_transaction(\@pkg_lines, $package);
    debug_print "Calling make_ips_files";
    make_ips_files(\@manifest_lines, $spec, $package);
    # must call make_ips_dependency after make_ips_files so that we can
    # run the dependency generator against the file list
    debug_print "Calling make_ips_dependency";
    make_ips_dependency(\@manifest_lines, $spec, $package);
    debug_print "Calling make_ips_actions";
    make_ips_actions(\@manifest_lines, $package);
    debug_print "Calling add_ips_summary";
    add_ips_summary(\@manifest_lines, $package, $src_fmri);
    debug_print "Calling add_ips_license";
    add_ips_legacy(\@manifest_lines, $spec, $package);
    add_ips_license(\@manifest_lines, $package); 
    debug_print "Calling close_ips_transaction";
    close_ips_transaction(\@pkg_lines);
    
    my $esc_name = $package->get_ips_name();
    $esc_name =~ s/\//%2F/g;
    my $script = $spec->eval ("%_pkgmapdir") . "/scripts/" .
	$esc_name . "_ips.sh";
    my $manifest = $spec->eval ("%_pkgmapdir") . "/manifests/" .
	$esc_name . ".manifest";

    debug_print "Prepare script - $script";
    prepare_ips_script($spec, $script, \@pkg_lines);
    debug_print "Prepare manifest - $manifest";
    prepare_ips_manifest($spec, $manifest, \@manifest_lines);
}

sub create_ips_src_package ($) {
    my $spec = shift;

    my @packages = $spec->get_packages ();
    return if not defined $packages[0];
    my $package = $packages[0];

    debug_print "Publishing ips source package";

    my @pkg_lines;
    my @manifest_lines;
    debug_print "Calling ips_transaction";
    open_ips_transaction(\@pkg_lines, $package, 1);
    debug_print "Calling make_ips_files";
    make_ips_src_files(\@manifest_lines, $spec);
    debug_print "Calling add_ips_summary";
    add_ips_summary(\@manifest_lines, $package, "-src");
    debug_print "Calling add_ips_license";
    add_ips_legacy(\@manifest_lines, $spec, $package, 1);
    add_ips_license(\@manifest_lines, $package); 
    debug_print "Calling close_ips_transaction";
    close_ips_transaction(\@pkg_lines);
    
    my $esc_name = $package->get_name ();
    $esc_name =~ s/\//%2F/g;
    my $script = $spec->eval ("%_pkgmapdir") . "/scripts/" .
	$esc_name . "_src_ips.sh";
    my $manifest = $spec->eval ("%_pkgmapdir") . "/manifests/" .
	$esc_name . "_src.manifest";

    debug_print "Prepare script - $script";
    prepare_ips_script($spec, $script, \@pkg_lines);
    debug_print "Prepare manifest - $manifest";
    prepare_ips_manifest($spec, $manifest, \@manifest_lines);
}

# publish the source package, return the fmri so it can be included
# in the metainfo of the binary package
sub publish_src_ips_package ($) {
    my $spec = shift;

    my $retval;
    my $script = $spec->eval ("%_pkgmapdir") . "/scripts/" .
	$spec->get_name() . "_src_ips.sh";
    print "Calling script $script\n";
    `chmod +x $script`;
    my $msg = `$script`;
    $retval = (! $?);
    print $msg;

    my $src_pkgname = $spec->eval ("%{?ips_sourcepackage}%{!?ips_sourcepackage:%name/src}");
    if (defined ($msg) and $msg =~ /^PUBLISHED\npkg:\/[^@]+@([^\n]+)/s) {
	return "$src_pkgname@$1";
    } else {
	return undef;
    }
}

# publish an IPS package
sub publish_ips_packages ($) {
    my $spec = shift;

    my $retval = 1;
    my @pkgs = $spec->get_packages ();
    foreach my $pkg (@pkgs) {
	next if $pkg->is_subpkg ();
	if (not $pkg->has_files (1)) {
	    my $make_empty = $pkg->get_value_of("pkgbuild_make_empty_package");
	    next if not defined ($make_empty);
	    next if ($make_empty ne "1" and $make_empty ne "true");
	}
	my $esc_name = ${pkg}->get_ips_name();
	$esc_name =~ s/\//%2F/g;
	my $script = $spec->eval ("%_pkgmapdir") . "/scripts/" .
	     ${esc_name} . "_ips.sh";
	print "Calling script $script\n";
	`chmod +x $script`;
	my $msg = `$script`;
	$retval = (! $?);
	print $msg;
    }
    return $retval;
}

# Save pkg lines array to a script that publishes all info to the ips repository
sub prepare_ips_script($$$) {
    my $spec = shift;
    my $file = shift;
    my $ref_lines = shift;
    
    my @lines = @$ref_lines;
    my $build_dir = $spec->eval('%buildroot');
    open FW, ">$file" or die "Failed to open file $file for writing\n";

    print FW "#!/usr/bin/bash\n";
    
    foreach $line (@lines) {
	print FW "$line \n";
    }
    close FW; 
}

# Save manifest lines array to a file that gets included when the package
# is sent to the IPS repository

sub prepare_ips_manifest($$$) {
    my $spec = shift;
    my $file = shift;
    my $ref_lines = shift;
    
    my @lines = _uniq(@$ref_lines);
    my $build_dir = $spec->eval('%buildroot');
    open FW, ">$file" or die "Failed to open file $file for writing\n";
    
    foreach $line (@lines) {
	print FW "$line\n";
    }
    close FW;
}

sub create_svr4_packages ($) {
    my $spec = shift;
    my $has_files_at_all = 0;

    if ($os ne 'solaris') {
#	return 1;
    }

    my @packages = $spec->get_packages ();

    foreach my $pkg (@packages) {
	my $make_empty = $pkg->get_value_of("pkgbuild_make_empty_package");
	if ($pkg->has_files()) {
	    if (not $pkg->has_svr4_match()) {
		$has_files_at_all = 1;
		make_solaris_pkg ($spec, $pkg) or return 0;
	    }
	} else {
	    if (defined ($make_empty) and ($make_empty eq "1" or
					   $make_empty eq "true")) {
		$has_files_at_all = 1;
		if (not $pkg->has_svr4_match()) {
		    make_solaris_pkg ($spec, $pkg) or return 0;
		}
	    }
	}
    }

    my $unpackaged = 0;
    my $unpackaged_files_terminate_build =
	$spec->eval ("%_unpackaged_files_terminate_build");
    if ($has_files_at_all) {
	my $buildroot = $spec->eval ("%buildroot");
	if ($buildroot ne "/" and -d $buildroot) {
	    my $old_cwd = `pwd`;
	    chdir ($buildroot) or
		$spec->_set_error ("Failed to access directory $buildroot")
		and return 0;
	    my @all_fnames = list_all_files (".");
	    foreach my $fname (@all_fnames) {
		$fname = substr ($fname, 2);
		if (not defined ($all_files{$fname})) {
		    if (not $unpackaged) {
			$unpackaged = 1;
			if ($unpackaged_files_terminate_build) {
			    print "error: ";
			    # FIXME _set_error is private...
			    $spec->_set_error ("Installed (but unpackaged) file(s) found");
			} else {
			    print "WARNING: ";
			}
			print "Installed (but unpackaged) file(s) found:\n";
		    }
		    print "        /$fname\n";
		}
	    }
	    chdir ($old_cwd);
	}
    }
    
    if ($unpackaged_files_terminate_build and $unpackaged) {
	return 0;
    }
    return 1;
}

sub make_src_pkginfo ($$) {
    my $spec = shift;
    my $pkgname = shift;

    my $fhandle = "pkginfo" . ++$file_id;

    my $pkginfodir = $spec->eval ("%_pkgmapdir") . "/pkginfo";
    my $fname = $pkgname . ".pkginfo";
    open $fhandle, ">$pkginfodir/$fname" or
	fatal ("failed to create file $pkginfodir/$fname");

    print $fhandle "PKG=" . $pkgname . "\n";
    my $summary = $spec->get_value_of ('summary');
    $summary = $pkgname unless defined ($summary);
    print $fhandle "NAME=$summary - sources\n";
    print $fhandle "DESC=$summary - sources\n";
    print $fhandle "ARCH=$build_arch\n";

    my $prodname = $spec->get_value_of ('sunw_prodname');
    print $fhandle "SUNW_PRODNAME=$prodname\n" if $prodname;

    my $prodvers = $spec->get_value_of ('sunw_prodvers');
    print $fhandle "SUNW_PRODVERS=$prodvers\n" if $prodvers;
    print $fhandle "SUNW_PKGTYPE=usr\n";

    my $pkgvers = $spec->get_value_of ('sunw_pkgvers');
    $pkgvers = "1.0" unless $pkgvers;
    print $fhandle "SUNW_PKGVERS=$pkgvers\n";

    my $category = $spec->get_value_of ('sunw_category');
    if (not defined ($category)) {
	$category = "application";
    }
    print $fhandle "CATEGORY=$category,SOURCE\n";

    my $vendor = $spec->get_value_of ('vendor');
    print $fhandle "VENDOR=$vendor\n" if $vendor;

    my $hotline = $spec->get_value_of ('sunw_hotline');
    print $fhandle "HOTLINE=$hotline\n" if $hotline;
    print $fhandle "EMAIL=\n";

    my $maxinst = $spec->get_value_of ('sunw_maxinst');
    print $fhandle "MAXINST=$maxinst\n" if $maxinst;

    my $version = $spec->eval ('%version');
    my $rev = $spec->get_value_of ('sunw_rev');
    if (not defined $rev) {
	$rev = `date +%Y.%m.%d.%H.%M`;
    } else {
	$rev = "$rev." . `date +%Y.%m.%d.%H.%M`;
    }
    chomp ($rev);
    print $fhandle "VERSION=$version,REV=$rev\n";
    print $fhandle "BASEDIR=/usr\n";
    print $fhandle "CLASSES=none\n";

    close $fhandle;
    return "i pkginfo=$pkginfodir/$fname\n";
}

# source package contents:
# SOURCES/
#    Source<1..n>
#    Patch<1..m>
#    SUNW_CopyRight
#    Class action script files
# SPECS/
#    $self->{file_name}
#    %use'd spec files (recursively)
#    %include'd files (recursively)
sub make_ips_src_files ($$$) {
    my $ref_lines = shift;
    my $spec = shift;

    if ($os ne 'solaris') {
#	return 1;
    }

    my $svr4_pkg_name = $spec->get_value_of ("sunw_pkg");
    $svr4_pkg_name = $spec->get_name () if not defined $svr4_pkg_name;
    my $base_pkg_version = $spec->eval ("%version");
    my $svr4_src_pkg_name = $spec->get_svr4_src_pkg_name ();

    my @sources = $spec->get_public_sources ();

    my @patches = $spec->get_public_patches ();

    my $copyright = $spec->get_value_of ("sunw_copyright");

    my @script_files = $spec->get_class_script_names ();

    my @includes = $spec->get_included_files ();

    my $this_spec_file = $spec->get_file_name ();
    if (not $this_spec_file =~ /^\//) {
	$this_spec_file = "$mydir/$this_spec_file";
    }

    my @used_spec_files = $spec->get_used_spec_files ();

    my $relocdir = $spec->eval ("%_srcpkgdir") . "/" . $svr4_src_pkg_name . "/reloc/share/src/" . $svr4_pkg_name . "-" . $base_pkg_version;
    my $dirname = "$spec";
    while ($dirname =~ /\//) {
	# the package name is "foo/bar/blah" style
	# so create directory entries for "foo" and "foo/bar"
	$dirname = dirname ($dirname);
	push (@$ref_lines, "dir mode=0555 owner=root group=bin path=\"share/src/$dirname\"");
    }
    my $srcdir = "share/src/${spec}-${base_pkg_version}/SOURCES";
    my $specdir = "share/src/${spec}-${base_pkg_version}/SPECS";

    push(@$ref_lines, "dir mode=0555 owner=root group=bin path=\"share/src/${spec}-${base_pkg_version}\"");
     push(@$ref_lines, "dir mode=0555 owner=root group=bin path=\"$srcdir\"");
    push(@$ref_lines, "dir mode=0555 owner=root group=bin path=\"$specdir\"");
    
    my $topdir = $spec->eval ("%_topdir");
    foreach my $fname (@sources, @patches, $copyright, @script_files) {
	next if not $fname;
	$fname =~ s/^.*\/([^\/]+)/$1/;
	push(@$ref_lines, "file $relocdir/SOURCES/$fname mode=0444 owner=root group=bin path=\"usr/$srcdir/$fname\"");
    }

    foreach my $fname (@includes, @used_spec_files) {
	next if not $fname;
	if (not $fname =~ /\//) {
	    push(@$ref_lines, "file $relocdir/SPECS/$fname mode=0444 owner=root group=bin path=\"usr/$specdir/$fname\"");
        } else {
            my $basefname = $fname;
            $basefname =~ s/^.*\/([^\/]+)/$1/;
	    push(@$ref_lines, "file $relocdir/SPECS/$basefname mode=0444 owner=root group=bin path=\"usr/$specdir/$basefname\"");
        }
    }
    my $base_spec_name = $this_spec_file;
    $base_spec_name =~ s/^.*\/([^\/]*)$/$1/;
    push(@$ref_lines, "file $relocdir/SPECS/$base_spec_name mode=0444 owner=root group=bin path=\"usr/$specdir/$base_spec_name\"");
    push(@$ref_lines, "link path=\"usr/$specdir/..main.spec\" target=\"$base_spec_name\"");
    push(@$ref_lines, "file /usr/lib/pkgbuild-1.3.104/version-file mode=0444 owner=root group=bin path=\"usr/$srcdir/..pkgbuild\"");
}


# source package contents:
# SOURCES/
#    Source<1..n>
#    Patch<1..m>
#    SUNW_CopyRight
#    Class action script files
# SPECS/
#    $self->{file_name}
#    %use'd spec files (recursively)
#    %include'd files (recursively)
sub make_src_package ($) {
    my $spec = shift;

    if ($os ne 'solaris') {
#	return 1;
    }

    my $base_pkg_name = $spec->get_value_of ("sunw_pkg");
    $base_pkg_name = $spec->get_name () if not defined $base_pkg_name;
    my $base_pkg_version = $spec->eval ("%version");

    my $src_pkg_name = $spec->get_value_of ("sourcepackage");
    if (not defined $src_pkg_name) {
	$src_pkg_name = $base_pkg_name;
	$src_pkg_name .= "-src";
    }

    my @sources = $spec->get_public_sources ();

    my @patches = $spec->get_public_patches ();

    my $copyright = $spec->get_value_of ("sunw_copyright");

    my @script_files = $spec->get_class_script_names ();

    my @includes = $spec->get_included_files ();

    my $this_spec_file = $spec->get_file_name ();
    if (not $this_spec_file =~ /^\//) {
	$this_spec_file = "$mydir/$this_spec_file";
    }

    my @used_spec_files = $spec->get_used_spec_files ();

    my $pkginfo_line = make_src_pkginfo ($spec, $src_pkg_name);
    my $copyright_line = make_copyright ($spec, undef, $src_pkg_name);

    my $fhandle = "proto" . ++$file_id;

    my $protodir = $spec->eval ("%_pkgmapdir") . "/proto";
    my $fname = $src_pkg_name . ".proto";
    open $fhandle, ">$protodir/$fname" or
	fatal ("failed to create file $protodir/$fname");

    print $fhandle $pkginfo_line;
    if (defined $copyright_line) {
	print $fhandle $copyright_line;
    }

    my $srcdir = "share/src/${base_pkg_name}-${base_pkg_version}/SOURCES";
    my $specdir = "share/src/${base_pkg_name}-${base_pkg_version}/SPECS";
    print $fhandle "d none share 0755 root sys\n";
    print $fhandle "d none share/src 0755 root sys\n";
    print $fhandle "d none $srcdir 0755 root other\n";
    print $fhandle "d none $specdir 0755 root other\n";

    my $topdir = $spec->eval ("%_topdir");
    foreach my $fname (@sources, @patches, $copyright, @script_files) {
	next if not $fname;
	$fname =~ s/^.*\/([^\/]+)/$1/;
	print $fhandle "f none $srcdir/$fname=$topdir/SOURCES/$fname 644 root other\n";
    }

    foreach my $fname (@includes, @used_spec_files) {
	next if not $fname;
	if (not $fname =~ /\//) {
	    print $fhandle "f none $specdir/$fname=$topdir/SPECS/$fname 644 root other\n";
        } else {
            my $basefname = $fname;
            $basefname =~ s/^.*\/([^\/]+)/$1/;
            print $fhandle "f none $specdir/$basefname=$fname 644 root root\n";
        }
    }
    my $base_spec_name = $this_spec_file;
    $base_spec_name =~ s/^.*\/([^\/]*)$/$1/;
    print $fhandle "f none $specdir/$base_spec_name=$this_spec_file 644 root other\n";
    print $fhandle "s none $specdir/..main.spec=$base_spec_name\n";
    print $fhandle "f none $specdir/..pkgbuild=/usr/lib/pkgbuild-1.3.104/version-file 444 root other\n";

    close ($fhandle);

    my $spkgdir = $spec->eval ("%_srcpkgdir");
    system ("/usr/bin/pkgmk -o -r / -d $spkgdir -f $protodir/$fname");
    my $retval = $?;
    if ($retval) {
	return 0;
    }

    if ($pkgformat eq "datastream") {
	my $dsname = "${src_pkg_name}-${base_pkg_version}.src.pkg";
	system ("/usr/bin/pkgtrans -o -s $spkgdir $spkgdir/$dsname $src_pkg_name");
	$retval = $?;
	if (not $retval) {
	    system ("rm -rf $spkgdir/$src_pkg_name");
	}
    }

    return (not $retval);
}

sub get_arch($) {
    my $spec = shift;

    # has the user specified an explicit target using --target?
    return $target if $target ne '';

    # look for package-provided arch, if any
    my @packages = $spec->get_packages ();
    my $pkg_arch = $packages[0]->get_value_of ("buildarch");
    if (not defined ($pkg_arch)) {
	$pkg_arch = $packages[0]->get_value_of ("buildarchitectures");
    }
    return $arch if not defined($pkg_arch);
    $pkg_arch = $spec->eval ($pkg_arch);
    # rpm noarch is mapped on svr4 all
    $pkg_arch = "sparc,i386" if $pkg_arch eq "noarch";
    return $pkg_arch;
}

sub get_pkg_arch($) {
    my $pkg = shift;

    # has the user specified an explicit target using --target?
    return $target if $target ne '';

    # look for package-provided arch, if any
    my $pkg_arch = $pkg->get_value_of ("buildarch");
    if (not defined ($pkg_arch)) {
	$pkg_arch = $pkg->get_value_of ("buildarchitectures");
    }
    return $arch if not defined($pkg_arch);
    $pkg_arch = $pkg->eval ($pkg_arch);
    # rpm noarch is mapped on svr4 all
    $pkg_arch = "sparc,i386" if $pkg_arch eq "noarch";
    return $pkg_arch;
}

sub main () {
    process_options ();

    print "Package format is $pkgformat\n";

    if ($pkgformat eq 'ips') {
	$pkgdb = new pkgdb(1);
    } else {
	$pkgdb = new pkgdb;
    }

    $pkgdb->set_verbosity($verbose);

    init ();

    if (not @spec_names) {
	if (not defined $build_command and $version_printed) {
	    exit (0);
	}
	fatal ("no spec files given for build");
    }

    if (not defined $build_command) {
	usage ();
    }

    foreach my $spec_name (@spec_names) {
	my $spec = new rpm_spec ($spec_name, \@predefines);
	if (not defined $spec) {
	    fatal ("File is not a regular file: $spec_name");
	}
	my $name = $spec->get_value_of ("name");

	my $topdir = $spec->eval ("%_topdir");
	$pkgdb -> set_topdir ($topdir);

	if (defined ($spec->{error})) {
	    fatal ($spec->{error});
	}
	if (not defined($name)) {
	    fatal ("The Name tag is not defined in " .
		   $spec->get_file_name());
	}
	$build_arch = get_arch($spec);
	if ($check_deps) {
	    check_build_requires ($spec) or exit (1);
	}
	if ($build_command =~ /p/) {
	    my $builddir = $spec->eval ("%_builddir");
	    mkdir_p ($builddir) or 
		fatal ("Failed to create directory $builddir");
	    do_block ($spec, 'prep') or exit (1);
	}
	if ($build_command =~ /c/) {
	    do_block ($spec, 'build') or exit (1);
	}
	if ($build_command =~ /i/) {
	    do_block ($spec, 'install') or exit (1);
	    do_block ($spec, 'check') or exit (1);
	}

	if ($build_command =~ /[bas]/) {
	    $pkgdir = $spec->eval ("%_pkgmapdir");
	    foreach my $subdir ("copyright", "depend", "pkginfo", "proto", "manifests", "scripts") {
		mkdir_p ("$pkgdir/$subdir")
		    or fatal ("Failed to create directory $pkgdir/$subdir");
	    }
	}

	my $src_fmri;
	if ($build_command =~ /[as]/ and $sourcepkg) {
	    $pkgdir = $spec->eval ("%_srcpkgdir");
	    mkdir_p ($pkgdir) or fatal ("Failed to create directory $pkgdir");
	    make_src_package ($spec) or
		fatal ($spec->get_error ());
	    if ($pkgformat eq "ips") {
		# Create IPS source package
		create_ips_src_package ($spec);
		$src_fmri = publish_src_ips_package ($spec);
	    }
	} 
	if ($build_command =~ /[ba]/) {
	    print "Creating packages...\n";
	    my $pkgdir = $spec->eval ("%_pkgdir");
	    mkdir_p ($pkgdir) or fatal ("Failed to create directory $pkgdir");
	    
	    $pkgdir = $spec->eval ("%_pkgmapdir");
	    foreach my $subdir ("copyright", "depend", "pkginfo", "proto", "manifests", "scripts") {
		mkdir_p ("$pkgdir/$subdir")
		    or fatal ("Failed to create directory $pkgdir/$subdir");
	    }
	    
	    # Create an SVr4 package
	    create_svr4_packages ($spec) or 
		fatal ($spec->get_error ());
	    
	    if ($pkgformat eq "ips") {
		# Create IPS package(s)
		create_ips_packages ($spec, $src_fmri);
		# Call the script to publish it
		if (not publish_ips_packages ($spec)) {
		    print "ERROR: failed to publish package to $ips_server\n";
		    exit (1);
		}
	    }
	}
	if ($build_command =~ /[ba]/) {
		do_block ($spec, 'clean') or exit (1);
	}
   }
}

main();
